<?php
// $Revision: 1.1.2.4 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

if ( ! defined( 'XOOPS_ROOT_PATH' ) ) exit();

// check token ticket
//require_once( '../class/base/gtickets.php' );
//$ticket_area = 'xoonips_admin_maintenance_ranking';
//if ( ! $xoopsGTicket->check( true, $ticket_area, false ) ) {
//  redirect_header( $xoonips_admin['mypage_url'], 3, $xoopsGTicket->getErrors() );
//  exit();
//}

// load xoonips abstract layer for xnpRecalcRanking()
include_once '../include/lib.php';
require_once '../include/create_session.php';
xnp_load_init_create_session();
$xnpsid = $_SESSION['XNPSID'];

// get requests
$post_keys = array(
  'ranking_download_file' => array( 's', false, true ),
);
$post_vals = xoonips_admin_get_requests( 'post', $post_keys );
$download_file_name = $post_vals['ranking_download_file'];

// logic
// TODO: use object handler
$table_names = array( 'viewed_item', 'downloaded_item', 'contributing_user', 'searched_keyword', 'active_group', 'new_item', 'new_group' );
$table_columns = array( 'item_id, count', 'item_id, count', 'item_id, uid, timestamp', 'keyword, count', 'gid, count', 'item_id, timestamp', 'gid, timestamp', );

/** sql -> csv file */
function xnp_dump_ranking( $filename, $sql ){
  global $xoopsDB;
  $h = fopen( $filename, 'w'  );
		
  $result = $xoopsDB->query( $sql );
  while ( $Row = $xoopsDB->fetchRow( $result ) ){
    $ar = array();
    foreach ( $Row as $val ){
      if ( is_numeric( $val ) ) $ar[] = $val;
      else                      $ar[] = urlencode( $val );
    }
    fputs( $h, implode( ',', $ar ) . "\n" );
  }
  fclose( $h );
}

/** assoc -> csv file */
function xnp_dump_assoc( $filename, $assoc ){
  global $xoopsDB;
  $h = fopen( $filename, 'w'  );
  
  foreach ( $assoc as $key => $val ){
    fputs( $h, "$key,$val\n" );
  }
  fclose( $h );
}
	
function onShutdown(){
  global $removeFiles;
  global $removeDir;
  foreach ($removeFiles as $file)
    unlink($file);
  if ($removeDir) rmdir($removeDir);
}

// zip xoonips_ranking_sum_* and let download it
function download_log( $now, $sum_start, $sum_last_update ){
  global $xoopsDB, $table_names, $table_columns;
  global $download_file_name;
  $now = time();
  $removeDirs  = array(); // Directories to remove at the end of the procedures.
  $removeFiles = array(); // Files to remove at the end of the procedures.
  register_shutdown_function('onShutdown');

  $dir = tempnam( '/tmp', 'xnp_ranking' );
  $zipFile = tempnam( '/tmp', 'xnp_ranking_zip' );
  unlink( $dir );
  mkdir ( $dir );
  $removeDir[] = $dir;

  $zippedFiles = array();
  chdir($dir);
  for ( $i = 0; $i < count($table_names); $i++ ){
     $filename = $table_names[$i];
     $zippedFiles[] = $filename;
     $removeFiles[] = "$dir/$filename";
     $sql = "SELECT ". $table_columns[$i]. " FROM " . $xoopsDB->prefix("xoonips_ranking_sum_".$table_names[$i]);
     $result = xnp_dump_ranking( "$dir/$filename", $sql );
  }
  $zippedFiles[] = "config";
  $removeFiles[] = "$dir/config";
  $result = xnp_dump_assoc( "$dir/config", array( 'ranking_sum_last_update' => $sum_last_update, 'ranking_sum_start' => $sum_start ) );

  $removeFiles[] = $zipFile;
  $result = xnp_zip_create( $zipFile, $zippedFiles );

  session_cache_limiter('none'); // avoid IE bug1 : see http://jp2.php.net/header  Harry 10-Dec-2004 03:26

  $size = filesize( $zipFile );

  // If character auto translation ON -> OFF
  if ( function_exists( 'mb_http_output' ) ) {
    mb_http_output( 'pass' );
  }

  header("Cache-Control: none");  // avoid IE bug 2
  header("Content-Type: application/zip");
  header("Content-Disposition: attachment; filename=\"$download_file_name\"");
  header("Content-Length: $size");
  readfile( $zipFile );
}
$now = time();

// set ranking_sum_start, ranking_sum_last_update
if ( RES_OK != xnp_get_config_value( 'ranking_sum_start', $sum_start ) || $sum_start == 0 ){
  $sql = "select min(timestamp) from ".$xoopsDB->prefix('xoonips_event_log');
  $result = $xoopsDB->query( $sql );
  if ( $xoopsDB->getRowsNum( $result ) ){
    list( $sum_start ) = $xoopsDB->fetchRow( $result );
    xnp_set_config_value( 'ranking_sum_start', $sum_start );
  }
 }
if ( RES_OK != xnp_get_config_value( 'ranking_sum_last_update', $sum_last_update ) || $sum_last_update == 0 ){
  $sum_last_update = $sum_start;
  xnp_set_config_value( 'ranking_sum_last_update', $sum_last_update );
 }

/*  
                                     v last_update
                   v sum_last_update       v now
        --------------log------------------+
        ---sum-----+
                   +-----------------------+  // add this to sum
   ranking_sum_last_update = now;
  
   if ( days_enabled == true ){
                          +---cache----+      // before
       update cache.
                             +----cache----+  // after 
    } else {
        ----------------------cache----+      // before
       copy sum to cache.                    
        ----------------------cache--------+  // after 
    }
 
    let download ranking_sum_* 
*/
$h = xnpLockRanking();
if ( $h ){
  xnpRecalcRankingSql( "( $sum_last_update <= timestamp and timestamp < $now )" , " 0 ", true );
  xnp_set_config_value( 'ranking_sum_last_update', "$now" );
  $sum_last_update = $now;
  xnpUnlockRanking( $h );
} else {
     redirect_header( $xoonips_admin['mypage_url'], 3, _AM_XOONIPS_MAINTENANCE_RANKING_LOCKED );
   exit();
}

if ( $days_enabled ){
  xnpRecalcRanking( true );
} else {
  // copy tables
  for ( $i = 0; $i < count($table_names); $i++ ){
    $xoopsDB->query( "delete from  " . $xoopsDB->prefix('xoonips_ranking_'.$table_names[$i]) );
    $sql =  "replace into " . $xoopsDB->prefix('xoonips_ranking_'.$table_names[$i])." ( " . $table_columns[$i]. " ) select ".$table_columns[$i]." from " . $xoopsDB->prefix('xoonips_ranking_sum_'.$table_names[$i]);
    $xoopsDB->query( $sql );
  }
}
download_log( $now, $sum_start, $sum_last_update );
exit();

?>
