<?php
// $Revision: 1.1.2.3 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

include_once XOOPS_ROOT_PATH . '/modules/xoonips/class/base/tableobject.class.php';

/**
 * @brief data object of changelog
 *
 * @li getVar('log_id') :
 * @li getVar('uid') :
 * @li getVar('item_id') :
 * @li getVar('log_date') :
 * @li getVar('log') :
 *
 */
class XooNIpsChangelog extends XooNIpsTableObject
{
    function XooNIpsChangelog() 
    {
        parent::XooNIpsTableObject();
        $this->initVar('log_id', XOBJ_DTYPE_INT, 0, false);
        $this->initVar('uid', XOBJ_DTYPE_INT, null, true);
        $this->initVar('item_id', XOBJ_DTYPE_INT, null, false);
        $this->initVar('log_date', XOBJ_DTYPE_INT, null, false);
        $this->initVar('log', XOBJ_DTYPE_TXTBOX, null, 65535);
    }
}

/**
 * @brief handler object of changelog
 *
 *
 */
class XooNIpsChangelogHandler extends XooNIpsTableObjectHandler
{
    function XooNIpsChangelogHandler(&$db) 
    {
        parent::XooNIpsTableObjectHandler($db);
        $this->__initHandler('XooNIpsChangelog', 'xoonips_changelog', 'log_id');
    }
}
?>
