<?php
// $Revision: 1.4.4.2 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

/* page to show event log graph (for moderators).
 * 
 * input:
 *    $_POST['StartDateYear' ]
 *    $_POST['StartDateMonth']
 *    $_POST['StartDateDay'  ]
 *    $_POST['EndDateYear'   ]
 *    $_POST['EndDateMonth'  ]
 *    $_POST['EndDateDay'    ]
 * 
 */

session_cache_limiter('none'); // Escape IE's Bug 1 -> http://jp2.php.net/header  Harry 10-Dec-2004 03:26

include '../../mainfile.php';
include_once 'include/create_session.php';
include_once 'include/lib.php';
include_once 'include/loggraph.php';
include_once 'condefs.php';

function error($message){
	header("HTTP/1.0 500 Internal Server Error");
	echo "error:" . $message;
	exit;
}

function error403(){
	header("HTTP/1.0 403 Forbidden");
	echo "403 Forbidden";
	exit;
}

function error404(){
	header("HTTP/1.0 404 Not Found");
	echo "404 Not Found";
	exit;
}

xnp_load_init_create_session();
$xnpsid = $_SESSION['XNPSID'];

if( !$xoopsUser ) {
	redirect_header( 'index.php', 3, _NOPERM );
	exit();
}
$uid = $xoopsUser->getVar('uid');
if ( !xnp_is_moderator( $xnpsid, $uid ) ){
	redirect_header( 'index.php', 3, _MD_XOONIPS_MODERATOR_SHULD_BE_MODERATOR );
	exit();
}

if( !empty( $_POST['log_type_id'] ) ){
	// clean xoops/xoonips session
	$sess_handler =& xoops_gethandler('session');
	$sess_handler->write(session_id(), session_encode()); // avoid being gc'ed
	$sess_handler->gc($xoopsConfig['session_expire'] * 60);
	xnpGcSession();
	
	// set variables
	$myts =& MyTextSanitizer::getInstance();
	$StartDateYear  = (int)$_POST['StartDateYear' ];
	$StartDateMonth = (int)$_POST['StartDateMonth'];
	$EndDateYear    = (int)$_POST['EndDateYear'   ];
	$EndDateMonth   = (int)$_POST['EndDateMonth'  ];
	$log_type_id = intval($_POST['log_type_id']);
	$GraphType   = $myts -> stripSlashesGPC( $_POST['DownloadType'][$log_type_id] );
	
	// If character's code changes automatic, it becomes invalid.
	if (function_exists('mb_http_output')){
		mb_http_output('pass');
	}
	
	// set log_type_id
	switch( $log_type_id ){
		case 1:
		case 2:
		case 3:
		case 4:
			$event_type_id = 22;
			break;
		case 5:
		case 6:
		case 7:
		case 8:
			$event_type_id = 7;
			break;
		case 9:
		case 10:
		case 11:
		case 12:
			$event_type_id = 8;
			break;
		case 13:
			$event_type_id = 16;
			break;
		case 14:
			$event_type_id = 4;
			break;
		default:
	}
	
	$_SESSION['event_type_id' ] = $event_type_id;
	$_SESSION['startdateyear' ] = $StartDateYear;
	$_SESSION['startdatemonth'] = $StartDateMonth;
	$_SESSION['enddateyear'   ] = $EndDateYear;
	$_SESSION['enddatemonth'  ] = $EndDateMonth;
	$_SESSION['graphtype'     ] = $GraphType;
	
}

$xoopsOption['template_main'] = 'xoonips_event_graph.html';
include XOOPS_ROOT_PATH.'/header.php';

if( !empty($log_type_id) ){
  $xoopsTpl->assign("log_id", $log_type_id);
  $xoopsTpl->assign("gra_id", mt_rand());
}
	

include XOOPS_ROOT_PATH.'/footer.php';


?>
