<?php
// $Revision: 1.11.4.1 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

/* page to download event log (for moderators).
 * 
 * input:
 *    $_POST['StartDateYear' ]
 *    $_POST['StartDateMonth']
 *    $_POST['StartDateDay'  ]
 *    $_POST['EndDateYear'   ]
 *    $_POST['EndDateMonth'  ]
 *    $_POST['EndDateDay'    ]
 * 
 */

session_cache_limiter('none'); // Escape IE's Bug 1 -> http://jp2.php.net/header  Harry 10-Dec-2004 03:26

include '../../mainfile.php';
require_once 'include/create_session.php';
require_once 'include/lib.php';
require_once 'include/loggraph.php';
require_once 'condefs.php';

function error($message){
	header("HTTP/1.0 500 Internal Server Error");
	echo "error:" . $message;
	exit;
}

function error403(){
	header("HTTP/1.0 403 Forbidden");
	echo "403 Forbidden";
	exit;
}

function error404(){
	header("HTTP/1.0 404 Not Found");
	echo "404 Not Found";
	exit;
}

xnp_load_init_create_session();
$xnpsid = $_SESSION['XNPSID'];

if( !$xoopsUser ) {
	redirect_header( 'index.php', 3, _NOPERM );
	exit();
}
$uid = $xoopsUser->getVar('uid');
if ( !xnp_is_moderator( $xnpsid, $uid ) ){
	redirect_header( 'index.php', 3, _MD_XOONIPS_MODERATOR_SHULD_BE_MODERATOR );
	exit();
}


if ( isset($_POST['download']) ){
	// clean xoops/xoonips session
	$sess_handler =& xoops_gethandler('session');
	$sess_handler->write(session_id(), session_encode()); // avoid being gc'ed
	$sess_handler->gc($xoopsConfig['session_expire'] * 60);
	xnpGcSession();
	
	// download CSV
	$StartDateYear  = (int)$_POST['StartDateYear' ];
	$StartDateMonth = (int)$_POST['StartDateMonth'];
	$StartDateDay   = (int)$_POST['StartDateDay'  ];
	$EndDateYear    = (int)$_POST['EndDateYear'   ];
	$EndDateMonth   = (int)$_POST['EndDateMonth'  ];
	$EndDateDay     = (int)$_POST['EndDateDay'    ];
	$filename = sprintf( '%04d%02d%02d-%04d%02d%02d.csv',$StartDateYear,$StartDateMonth,$StartDateDay,$EndDateYear,$EndDateMonth,$EndDateDay );
	$events = array();
	
	$startTime = mktime( 0, 0, 0, $StartDateMonth, $StartDateDay, $StartDateYear );
	$endTime   = mktime( 0, 0, 0, $EndDateMonth,   $EndDateDay,   $EndDateYear   ) + 60*60*24;
	$result = xnp_get_events( $xnpsid, $events, $startTime, $endTime );
	if ( $result != RES_OK ){
		error( "ERROR [AbstractLayer]".xnp_get_last_error_string() );
	}
	// If character's code changes automatic, it becomes invalid.
	if (function_exists('mb_http_output')){
		mb_http_output('pass');
	}

	header("Cache-Control: none");  // Escape IE's Bug 2
	//header("Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0"); // default cache-control's output
	header("Content-Type: text/csv");
	header("Content-Disposition: attachment; filename=\"$filename\"");
	//header("Content-Length: $size");

//	function dquote($str)
//	{
//		return '"' . str_replace( '"', '""', $str ) . '"';
//	}
	
	$event_types_str = explode( ',', _MI_XOONIPS_EVENT_LOG_EVENT_TYPES );
	
	$uid2uname = array( UID_GUEST => 'guest' );
	$result = $xoopsDB->query( "select uid, uname from " . $xoopsDB->prefix('users') );
	while ( list( $tmp_uid, $tmp_uname ) = $xoopsDB->fetchRow( $result ) ){
		$uid2uname[$tmp_uid] = $tmp_uname;
	}
	
	echo _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS . "\r\n"; // header
	//echo "<table border=1>\n";
	foreach ( $events as $event ){
		$event_type_str  = $event_types_str[$event['event_type_id']];
		$timestamp   = dquote( date( DATETIME_FORMAT, $event['timestamp']) );
		
		$exec_uid       = isset($event["exec_uid"       ]) ? $event["exec_uid"      ] : '';
		$index_id       = isset($event["index_id"       ]) ? $event["index_id"      ] : '';
		$item_id        = isset($event["item_id"        ]) ? $event["item_id"       ] : '';
		$file_id        = isset($event["file_id"        ]) ? $event["file_id"       ] : '';
		$tmp_uid        = isset($event["uid"            ]) ? $event["uid"           ] : '';
		$gid            = isset($event["gid"            ]) ? $event["gid"           ] : '';
		$remote_host    = isset($event["remote_host"    ]) ? dquote($event["remote_host"    ]) : '';
		$search_keyword = isset($event["search_keyword" ]) ? dquote($event["search_keyword" ]) : '';
		$additional_info= isset($event["additional_info"]) ? dquote($event["additional_info"]) : '';
		// $login_name     = isset($event["exec_uid"       ]) ? $uid2uname[$exec_uid] : '';
		// If $uid2uname is not given, $login_name is empty.
		if( isset( $event["exec_uid"] ) ){
			if ( isset( $uid2uname[$exec_uid] ) ){
				$login_name = $uid2uname[$exec_uid];
			} else {
				$login_name = '';
			}
		} else {
			$login_name = '';
		}
		
		echo "$event_type_str,$timestamp,$exec_uid,$remote_host,$index_id,$item_id,$file_id,$tmp_uid,$gid,$search_keyword,$login_name,$additional_info\r\n";
		//echo "<tr><td>$event_type_str</td><td>$timestamp</td><td>$exec_uid</td><td>$remote_host</td><td>$index_id</td><td>$item_id</td><td>$file_id</td><td>$tmp_uid</td><td>$gid</td><td>$search_keyword</td><td>$login_name</td><td>$additional_info</td></tr>\r\n";
	}
	//echo "</table>\n";
	exit;
}

if( !empty( $_POST['log_type_id'] ) ){
	// clean xoops/xoonips session
	$sess_handler =& xoops_gethandler('session');
	$sess_handler->write(session_id(), session_encode()); // avoid being gc'ed
	$sess_handler->gc($xoopsConfig['session_expire'] * 60);
	xnpGcSession();
	
	// download CSV
	$myts =& MyTextSanitizer::getInstance();
	$StartDateYear  = (int)$_POST['StartDateYear' ];
	$StartDateMonth = (int)$_POST['StartDateMonth'];
	$EndDateYear    = (int)$_POST['EndDateYear'   ];
	$EndDateMonth   = (int)$_POST['EndDateMonth'  ];
	$log_type_id = intval($_POST['log_type_id']);
	if( $log_type_id < 20 ){
		$DownloadType   = $myts -> stripSlashesGPC( $_POST['DownloadType'][$log_type_id] );
		$filename = sprintf( '%04d%02d-%04d%02d-%s.csv',$StartDateYear,$StartDateMonth,$EndDateYear,$EndDateMonth,$DownloadType );
//		$filename = sprintf( '%04d%02d-%04d%02d-%s.xls',$StartDateYear,$StartDateMonth,$EndDateYear,$EndDateMonth,$DownloadType );
		$events = array();

		// Prepare for Date
		if( $EndDateMonth >= 12 ){
			$EndDateMonth = 0;
			$EndDateYear = $EndDateYear + 1;
		}
		$EndDateMonth = $EndDateMonth + 1;
	
		// Set Date
		$start_time = mktime(0, 0, 0, $StartDateMonth, 1, $StartDateYear );
		$end_time   = mktime(0, 0, 0, $EndDateMonth, 1, $EndDateYear ) - 1;
	} else {
		if( $log_type_id == "20" ){
			$DownloadType = "user";
			$filename = sprintf( '%04d-%s.csv',$EndDateYear,$DownloadType );
		} elseif( $log_type_id == "21" ){
			$DownloadType = "item";
			$filename = sprintf( '%04d-%s.csv',$EndDateYear,$DownloadType );
		}
	}

	// If character's code changes automatic, it becomes invalid.
	if (function_exists('mb_http_output')){
		mb_http_output('pass');
	}

	header("Cache-Control: none");
	header("Content-Type: text/csv;");
	header("Content-Disposition: attachment; filename=\"$filename\"");

//	header("Content-Type: application/vnd.ms-excel;");
//	header("Content-Disposition: attachment; filename=\"$filename\"");


	switch( $log_type_id ){
		case 1:
			$event_type_id = 22;
			echo _MI_XOONIPS_EVENT_LOG_ACCESS_TOP_DAYS_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DATE . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventDays( $event_type_id, $arr, $start_time, $end_time );
			xnpLogDays($result, $start_time, $end_time);
			break;
		case 2:
			$event_type_id = 22;
			echo _MI_XOONIPS_EVENT_LOG_ACCESS_TOP_MONTHS_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DATE . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventMonths( $event_type_id, $arr, $start_time, $end_time );
			xnpLogMonths($arr, $StartDateYear, $StartDateMonth, $EndDateYear, $EndDateMonth, $start_time, $end_time);
			break;
		case 3:
			$event_type_id = 22;
			echo _MI_XOONIPS_EVENT_LOG_ACCESS_TOP_TOTAL_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DATE . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventDays( $event_type_id, $arr, $start_time, $end_time );
			xnpLogDaysTotal($result, $start_time, $end_time );
			break;
		case 4:
			$event_type_id = 22;
			echo _MI_XOONIPS_EVENT_LOG_ACCESS_TOP_DOMAINS_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DOMAINS . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventDomains( $event_type_id, $arr, $start_time, $end_time );
			xnpLogDomains($arr);
			break;
		case 5:
			$event_type_id = 7;
			echo _MI_XOONIPS_EVENT_LOG_ACCESS_ITEM_DAYS_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DATE . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventDays( $event_type_id, $arr, $start_time, $end_time );
			xnpLogDays($result, $start_time, $end_time );
			break;
		case 6:
			$event_type_id = 7;
			echo _MI_XOONIPS_EVENT_LOG_ACCESS_ITEM_MONTHS_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DATE . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventMonths( $event_type_id, $arr, $start_time, $end_time );
			xnpLogMonths($arr, $StartDateYear, $StartDateMonth, $EndDateYear, $EndDateMonth, $start_time, $end_time);
			break;
		case 7:
			$event_type_id = 7;
			echo _MI_XOONIPS_EVENT_LOG_ACCESS_ITEM_TOTAL_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DATE . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventDays( $event_type_id, $arr, $start_time, $end_time );
			xnpLogDaysTotal($result, $start_time, $end_time );
			break;
		case 8:
			$event_type_id = 7;
			echo _MI_XOONIPS_EVENT_LOG_ACCESS_ITEM_DOMAINS_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DOMAINS . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventDomains( $event_type_id, $arr, $start_time, $end_time );
			xnpLogDomains($arr);
			break;
		case 9:
			$event_type_id = 8;
			echo _MI_XOONIPS_EVENT_LOG_DL_ITEM_DAYS_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DATE . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventDays( $event_type_id, $arr, $start_time, $end_time );
			xnpLogDays($result, $start_time, $end_time );
			break;
		case 10:
			$event_type_id = 8;
			echo _MI_XOONIPS_EVENT_LOG_DL_ITEM_MONTHS_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DATE . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventMonths( $event_type_id, $arr, $start_time, $end_time );
			xnpLogMonths($arr, $StartDateYear, $StartDateMonth, $EndDateYear, $EndDateMonth, $start_time, $end_time);
			break;
		case 11:
			$event_type_id = 8;
			echo _MI_XOONIPS_EVENT_LOG_DL_ITEM_TOTAL_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DATE . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventDays( $event_type_id, $arr, $start_time, $end_time );
			xnpLogDaysTotal($result, $start_time, $end_time );
			break;
		case 12:
			$event_type_id = 8;
			echo _MI_XOONIPS_EVENT_LOG_DL_ITEM_DOMAINS_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DOMAINS . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventDomains( $event_type_id, $arr, $start_time, $end_time );
			xnpLogDomains($arr);
			break;
		case 13:
			$event_type_id = 16;
			echo _MI_XOONIPS_EVENT_LOG_NEW_USERS_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DATE . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventMonths( $event_type_id, $arr, $start_time, $end_time );
			xnpLogMonths($arr, $StartDateYear, $StartDateMonth, $EndDateYear, $EndDateMonth, $start_time, $end_time);
			break;
		case 14:
			$event_type_id = 4;
			echo _MI_XOONIPS_EVENT_LOG_NEW_ITEMS_LABEL . "\r\n" . _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DATE . "\r\n"; // header
			$arr = array();
			$result = xnpGetEventMonths( $event_type_id, $arr, $start_time, $end_time );
			xnpLogMonths($arr, $StartDateYear, $StartDateMonth, $EndDateYear, $EndDateMonth, $start_time, $end_time);
			break;
		case 15:
			$event_type_id = 8;
			$range = xnpLogLabelMonths($log_type_id, $arr, $StartDateYear, $StartDateMonth, $EndDateYear, $EndDateMonth, $start_time, $end_time);
			echo _MI_XOONIPS_EVENT_LOG_DL_ITEM_PER_ITEM_LABEL . "\r\n" . $range."\r\n"; // header
			$arr = array();
			$result1 = xnpGetEventDlItem( $event_type_id, $arr, $start_time, $end_time );
			$arr_mon = array();
			$result2 = xnpGetEventDlItemMonths( $event_type_id, $arr_mon, $start_time, $end_time );
			$arr_title = array();
			$result3 = xnpGetEventItemTitles( $arr, $arr_title );
			xnpLogDlItem($arr, $arr_mon, $arr_title, $range);
			break;
		case 16:
			$event_type_id = 8;
			$range = xnpLogLabelMonths($log_type_id, $arr, $StartDateYear, $StartDateMonth, $EndDateYear, $EndDateMonth, $start_time, $end_time);
			echo _MI_XOONIPS_EVENT_LOG_DL_ITEM_PER_FILE_LABEL . "\r\n" . $range."\r\n"; // header
			$arr = array();
			$result1 = xnpGetEventDlFile( $event_type_id, $arr, $start_time, $end_time );
			$arr_mon = array();
			$result2 = xnpGetEventDlFileMonths( $event_type_id, $arr_mon, $start_time, $end_time );
			$arr_title = array();
			$result3 = xnpGetEventItemTitles( $arr, $arr_title );
			xnpLogDlFile($arr, $arr_mon, $arr_title, $range);
			break;
		case 17:
			$event_type_id = 8;
			$range = xnpLogLabelMonths($log_type_id, $arr, $StartDateYear, $StartDateMonth, $EndDateYear, $EndDateMonth, $start_time, $end_time);
			echo _MI_XOONIPS_EVENT_LOG_DL_ITEM_PER_USER_LABEL . "\r\n" . $range."\r\n"; // header
			$arr = array();
			$result1 = xnpGetEventDlUser( $event_type_id, $arr, $start_time, $end_time );
			$arr_mon = array();
			$result2 = xnpGetEventDlUserMonths( $event_type_id, $arr_mon, $start_time, $end_time );
			$arr_dom = array();
			$resule3 = xnpLogEventLabelDomains( $arr, $arr_dom );
			xnpLogDlUser($arr, $arr_mon, $arr_dom, $range);
			break;
		case 18:
			$event_type_id = 7;
			$range = xnpLogLabelMonths($log_type_id, $arr, $StartDateYear, $StartDateMonth, $EndDateYear, $EndDateMonth, $start_time, $end_time);
			echo _MI_XOONIPS_EVENT_LOG_ACCESS_ITEM_PER_ITEM_LABEL . "\r\n" . $range."\r\n"; // header
			$arr = array();
			$result1 = xnpGetEventDlItem( $event_type_id, $arr, $start_time, $end_time );
			$arr_mon = array();
			$result2 = xnpGetEventDlItemMonths( $event_type_id, $arr_mon, $start_time, $end_time );
			$arr_title = array();
			$result3 = xnpGetEventItemTitles( $arr, $arr_title );
			xnpLogDlItem($arr, $arr_mon, $arr_title, $range);
			break;
		case 19:
			$event_type_id = 7;
			$range = xnpLogLabelMonths($log_type_id, $arr, $StartDateYear, $StartDateMonth, $EndDateYear, $EndDateMonth, $start_time, $end_time);
			echo _MI_XOONIPS_EVENT_LOG_ACCESS_ITEM_PER_USER_LABEL . "\r\n" . $range."\r\n"; // header
			$arr = array();
			$result1 = xnpGetEventAccessUser( $event_type_id, $arr, $start_time, $end_time );
			$arr_mon = array();
			$result2 = xnpGetEventAccessUserMonths( $event_type_id, $arr_mon, $start_time, $end_time );
			$arr_dom = array();
			$resule3 = xnpLogEventLabelDomains( $arr, $arr_dom );
			$arr_item = array();
			$result4 = xnpGetEventAccessUserItems($event_type_id, $arr_item, $start_time, $end_time);
			$arr_title = array();
			$result5 = xnpGetEventItemTitles( $arr_item, $arr_title );
			$arr_itemmon = array();
			$result6 = xnpGetEventAccessUserItemsMonths($event_type_id, $arr_itemmon, $start_time, $end_time);
			$arr_type = array();
			$result7 = xnpGetEventItemTypes( $arr_item, $arr_type );
			xnpLogAccessUser($arr, $arr_mon, $arr_title, $arr_dom, $arr_item, $arr_itemmon, $arr_type, $range);
			break;
		case 20:
			$usercnt = intval( xnp_get_account_count( $xnpsid ) );
			echo "User List,,".$usercnt."users" . "\r\n" . "Name,Company,Division,Email" . "\r\n"; // header
			xnpListDlRegiUser($xnpsid);
			break;
		case 21:
			$itemcnt = intval( xnp_get_item_count( $xnpsid ) );
			echo "Item List,,".$itemcnt."items" . "\r\n" . "Itemid,Title,ItemType,Contributor" . "\r\n"; // header
			xnpListDlRegiItem($xnpsid);
			break;
		default:
	}

}

$xoopsOption['template_main'] = 'xoonips_event_log.html';
include XOOPS_ROOT_PATH.'/header.php';
$xoopsTpl->assign('time', time() );
$xoopsTpl->assign('start_year', 2005 );
$xoopsTpl->assign('end_year', date('Y') );

// for Registered users and items.
$usercnt = intval( xnp_get_account_count( $xnpsid ) );
$xoopsTpl->assign('num_of_user', $usercnt);
$itemcnt = intval( xnp_get_item_count( $xnpsid ) );
$xoopsTpl->assign('num_of_item', $itemcnt);

include XOOPS_ROOT_PATH.'/footer.php';

?>
