<?php
// $Revision: 1.1.4.1 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

/* page to show event log view (for moderators).
 * 
 * input:
 *    $_POST['StartDateYear' ]
 *    $_POST['StartDateMonth']
 *    $_POST['StartDateDay'  ]
 *    $_POST['EndDateYear'   ]
 *    $_POST['EndDateMonth'  ]
 *    $_POST['EndDateDay'    ]
 * 
 */

session_cache_limiter('none'); // Escape IE's Bug 1 -> http://jp2.php.net/header  Harry 10-Dec-2004 03:26

include '../../mainfile.php';
include_once 'include/create_session.php';
include_once 'include/lib.php';
include_once 'include/loggraph.php';
include_once 'condefs.php';

function error($message){
	header("HTTP/1.0 500 Internal Server Error");
	echo "error:" . $message;
	exit;
}

function error403(){
	header("HTTP/1.0 403 Forbidden");
	echo "403 Forbidden";
	exit;
}

function error404(){
	header("HTTP/1.0 404 Not Found");
	echo "404 Not Found";
	exit;
}

xnp_load_init_create_session();
$xnpsid = $_SESSION['XNPSID'];

if( !$xoopsUser ) {
	redirect_header( 'index.php', 3, _NOPERM );
	exit();
}
$uid = $xoopsUser->getVar('uid');
if ( !xnp_is_moderator( $xnpsid, $uid ) ){
	redirect_header( 'index.php', 3, _MD_XOONIPS_MODERATOR_SHULD_BE_MODERATOR );
	exit();
}

if( !empty( $_POST['log_type_id'] ) ){
	// clean xoops/xoonips session
	$sess_handler =& xoops_gethandler('session');
	$sess_handler->write(session_id(), session_encode()); // avoid being gc'ed
	$sess_handler->gc($xoopsConfig['session_expire'] * 60);
	xnpGcSession();
	
	// set variables
	$myts =& MyTextSanitizer::getInstance();
	$log_type_id = intval($_POST['log_type_id']);
	
	// If character's code changes automatic, it becomes invalid.
	if (function_exists('mb_http_output')){
		mb_http_output('pass');
	}
}

$xoopsOption['template_main'] = 'xoonips_event_view.html';
include XOOPS_ROOT_PATH.'/header.php';


if( !empty($log_type_id) && $log_type_id == "20"){
	$dtcnt = xnp_get_account_count($xnpsid);
	$usercnt = isset($_POST['usercnt']) ? intval($_POST['usercnt']) : '20';
	$xoopsTpl->assign('usercnt', $usercnt);
	if( isset($_POST['orderby']) ){
		$orderby = $_POST['orderby'];
	} else {
		$orderby = 'uid';
	}
	$xoopsTpl->assign('orderby', $orderby);
	if( isset($_POST['order_dir']) ){
		$order_dir = $_POST['order_dir'];
	} else {
		$order_dir = '0';
	}
	$xoopsTpl->assign('order_dir', $order_dir);

	$xnp_page = isset($_POST['xnp_page']) ? intval($_POST['xnp_page']) : '1';
	
	$cri = array();
    $cri = array( 'start' => ( $xnp_page - 1 ) * $usercnt,
                  'rows' => $usercnt,
                  'orders'=>array( array( 'name'=>$orderby,'order'=>$order_dir ) ) );
	$cri2 = array();
    $cri2 = array( 'start' => ( $xnp_page - 1 ) * $usercnt,
                   'rows' => $usercnt,
                   'orders'=>array( array( 'name'=>$orderby,'order'=>$order_dir ) ) );
	
	$user_list = xnpListViewRegiUser($xnpsid, $cri, $cri2);
	$xoopsTpl->assign("user_list", $user_list);
	
	$xnp_pages = array( min( max( 1, $xnp_page - 4 ), max( 1, ceil( $dtcnt / $usercnt ) - 9 ) ) );
	for( $i = $xnp_pages[0] + 1; $i <= min( 10, ceil( $dtcnt / $usercnt ) ); $i++ ){ $xnp_pages[] = $i; }
	
	$page_no_label = min( ( $xnp_page - 1 ) * $usercnt + 1, $dtcnt )
	." - ".min($xnp_page * $usercnt, $dtcnt )
	." of ".$dtcnt." Users" ;
	
	$xoopsTpl->assign('maxpage', ceil( $dtcnt / $usercnt ) );
    $xoopsTpl->assign("order_by_select", array( "uid"=>"name",
                                                "company_name"=>"company" ) );

} elseif( !empty($log_type_id) && $log_type_id == "21" ){
	$dtcnt = xnp_get_item_count($xnpsid);
	$itemcnt = isset($_POST['itemcnt']) ? intval($_POST['itemcnt']) : '20';
	$xoopsTpl->assign('itemcnt', $itemcnt);
	if( isset($_POST['orderby']) ){
		$orderby = $_POST['orderby'];
	} else {
		$orderby = 'item_id';
	}
	$xoopsTpl->assign('orderby', $orderby);
	if( isset($_POST['order_dir']) ){
		$order_dir = $_POST['order_dir'];
	} else {
		$order_dir = '0';
	}
	$xoopsTpl->assign('order_dir', $order_dir);
	$xnp_page = isset($_POST['xnp_page']) ? intval($_POST['xnp_page']) : '1';
	$xnp_pages = array( min( max( 1, $xnp_page - 4 ), max( 1, ceil( $dtcnt / $itemcnt ) - 9 ) ) );
	for( $i = $xnp_pages[0] + 1; $i <= min( 10, ceil( $dtcnt / $itemcnt ) ); $i++ ){ $xnp_pages[] = $i; }
	
	$page_no_label = min( ( $xnp_page - 1 ) * $itemcnt + 1, $dtcnt )
	." - ".min($xnp_page * $itemcnt, $dtcnt )
	." of ".$dtcnt." Items" ;
	
	$cri = array();
    $cri = array( 'start' => ( $xnp_page - 1 ) * $itemcnt,
                  'rows' => intval($itemcnt),
                  'orders'=>array( array( 'name'=>$orderby,'order'=>$order_dir ) ) );
	$item_list = xnpListViewRegiItem($xnpsid, $cri);
	$xoopsTpl->assign("item_list", $item_list);
	$xoopsTpl->assign('maxpage', ceil( $dtcnt / $itemcnt ) );
    $xoopsTpl->assign("order_by_select", array( "item_id"=>"item id",
                                                "title"=>"title" ) );

}


	$xoopsTpl->assign('item_count_select', array( "20", "50", "100" ) );

	$xoopsTpl->assign('xnp_pages', $xnp_pages );
	$xoopsTpl->assign('prevpage', $xnp_page - 1 );
	$xoopsTpl->assign('nextpage', $xnp_page + 1 );
	$xoopsTpl->assign('xnp_page', $xnp_page);
	$xoopsTpl->assign('page_no_label', $page_no_label);


include XOOPS_ROOT_PATH.'/footer.php';

?>