<?php
// $Revision: 1.1.4.1 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

/* page to show event log graph (for moderators).
 * 
 * input:
 *    $_POST['StartDateYear' ]
 *    $_POST['StartDateMonth']
 *    $_POST['StartDateDay'  ]
 *    $_POST['EndDateYear'   ]
 *    $_POST['EndDateMonth'  ]
 *    $_POST['EndDateDay'    ]
 * 
 */

session_cache_limiter('none'); // Escape IE's Bug 1 -> http://jp2.php.net/header  Harry 10-Dec-2004 03:26

include '../../mainfile.php';
include_once 'include/create_session.php';
include_once 'include/lib.php';
include_once 'include/loggraph.php';
include_once 'condefs.php';

function error($message){
	header("HTTP/1.0 500 Internal Server Error");
	echo "error:" . $message;
	exit;
}

function error403(){
	header("HTTP/1.0 403 Forbidden");
	echo "403 Forbidden";
	exit;
}

function error404(){
	header("HTTP/1.0 404 Not Found");
	echo "404 Not Found";
	exit;
}

xnp_load_init_create_session();
$xnpsid = $_SESSION['XNPSID'];

if( !$xoopsUser ) {
	redirect_header( 'index.php', 3, _NOPERM );
	exit();
}
$uid = $xoopsUser->getVar('uid');
if ( !xnp_is_moderator( $xnpsid, $uid ) ){
	redirect_header( 'index.php', 3, _MD_XOONIPS_MODERATOR_SHULD_BE_MODERATOR );
	exit();
}


if( isset($_GET['lid']) ){
	$log_type_id = intval($_GET['lid']);

	$event_type_id  = (int)$_SESSION['event_type_id' ];
	$StartDateYear  = (int)$_SESSION['startdateyear' ];
	$StartDateMonth = (int)$_SESSION['startdatemonth'];
	$EndDateYear    = (int)$_SESSION['enddateyear'   ];
	$EndDateMonth   = (int)$_SESSION['enddatemonth'  ];
	$GraphType      = $_SESSION['graphtype'     ];

	if( $StartDateYear == $EndDateYear && $StartDateMonth == $EndDateMonth ){
		$DateLabel4Graph = sprintf( '%04d.%02d',$StartDateYear,$StartDateMonth );
	} else {
		$DateLabel4Graph = sprintf( '%04d.%02d-%04d.%02d',$StartDateYear,$StartDateMonth,$EndDateYear,$EndDateMonth );
	}

	// Prepare for Date
	if( $EndDateMonth >= 12 ){
		$EndDateMonth = 0;
		$EndDateYear = $EndDateYear + 1;
	}
	$EndDateMonth = $EndDateMonth + 1;

	// Set Date
	$start_time = mktime(0, 0, 0, $StartDateMonth, 1, $StartDateYear );
	$end_time   = mktime(0, 0, 0, $EndDateMonth, 1, $EndDateYear ) - 1;

	switch($log_type_id){
		case 1:
		case 5:
		case 9:
			$arr = array();
			$result = xnpGetEventDays( $event_type_id, $arr, $start_time, $end_time );
			xnpLogDaysLineGraph($result, $start_time, $end_time, $log_type_id, $GraphType, $DateLabel4Graph);
			break;
		case 2:
		case 6:
		case 10:
		case 13:
		case 14:
			$arr = array();
			$result = xnpGetEventMonths( $event_type_id, $arr, $start_time, $end_time );
			xnpLogMonthsBarGraph($result, $StartDateYear, $StartDateMonth, $EndDateYear, $EndDateMonth, $start_time, $end_time, $log_type_id, $GraphType, $DateLabel4Graph);
			break;
		case 3:
		case 7:
		case 11:
			$arr = array();
			$result = xnpGetEventDays( $event_type_id, $arr, $start_time, $end_time );
			xnpLogDaysTotalLineGraph($result, $start_time, $end_time, $log_type_id, $GraphType, $DateLabel4Graph);
			break;
		case 4:
		case 8:
		case 12:
			$arr = array();
			$result = xnpGetEventDomains( $event_type_id, $arr, $start_time, $end_time );
			xnpLogDomainsBarGraph($result, $log_type_id, $GraphType, $DateLabel4Graph);
			break;
		default:
	}
}
?>
