<?php
// $Revision: 1.4.4.2 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

include_once XOOPS_ROOT_PATH.'/modules/xoonips/condefs.php';
include_once 'encode.php';

/*
 *
 * function for access database
 *
 */
function xnpGetEventDays($event_type_id, &$arr, $start_time=0, $end_time=0 )
{
	global $xoopsDB;
	$event_type_id = (int)$event_type_id;
	$start_time = (int)$start_time;
	$end_time = (int)$end_time;
	$arr = array();
	
	$tab  = $xoopsDB->prefix('xoonips_event_log');
	$sql  = "SELECT from_unixtime(timestamp, '%Y-%m-%d') as event_date, count(event_type_id) FROM ".$tab." WHERE event_type_id = ".$event_type_id." and timestamp between ".$start_time." and ".$end_time." group by event_date order by event_date";
	$res = $xoopsDB->query($sql);
		if ($res == FALSE){
			echo "ERROR: " . $xoopsDB->error();
			return RES_DB_QUERY_ERROR;
		}
	while($row = $xoopsDB->fetchArray($res)){
		$a = $row['event_date'];
		$b = $row['count(event_type_id)'];
		$arr[$a] = $b;
	}
	
	return $arr;
}
function xnpGetEventMonths($event_type_id, &$arr, $start_time=0, $end_time=0 )
{
	global $xoopsDB;
	$event_type_id = (int)$event_type_id;
	$start_time = (int)$start_time;
	$end_time = (int)$end_time;
	$arr = array();
	
	$tab  = $xoopsDB->prefix('xoonips_event_log');
	$sql  = "SELECT from_unixtime(timestamp, '%Y-%m') as event_mdate, count(event_type_id) FROM ".$tab." WHERE event_type_id = ".$event_type_id." and timestamp between ".$start_time." and ".$end_time." group by event_mdate order by event_mdate";
	$res = $xoopsDB->query($sql);
		if ($res == FALSE){
			echo "ERROR: " . $xoopsDB->error();
			return RES_DB_QUERY_ERROR;
		}
	while($row = $xoopsDB->fetchArray($res)){
		$a = $row['event_mdate'];
		$b = $row['count(event_type_id)'];
		$arr[$a] = $b;
	}
	
	return $arr;

}

function xnpGetEventDomains($event_type_id, &$arr, $start_time=0, $end_time=0)
{
	global $xoopsDB;
	$event_type_id = (int)$event_type_id;
	$start_time = (int)$start_time;
	$end_time = (int)$end_time;
	$arr = array();
	
	$tab  = $xoopsDB->prefix('xoonips_event_log');
	$sql  = "SELECT remote_host AS dom, count(event_type_id) AS cnt FROM ".$tab." WHERE event_type_id = ".$event_type_id." and timestamp between ".$start_time." and ".$end_time." group by dom";
	$res = $xoopsDB->query($sql);
		if ($res == FALSE){
			echo "ERROR: " . $xoopsDB->error();
			return RES_DB_QUERY_ERROR;
		}
	while($row = $xoopsDB->fetchArray($res)){
		$dom = $row['dom'];
		$cnt = $row['cnt'];
		$arr[$dom] = $cnt;
	}
	
	return $arr;
}

function xnpGetEventDlItem($event_type_id, &$arr, $start_time=0, $end_time=0)
{
	global $xoopsDB;
	$event_type_id = (int)$event_type_id;
	$start_time = (int)$start_time;
	$end_time = (int)$end_time;
	
	$tab1 = $xoopsDB->prefix('xoonips_event_log');
	$tab2 = $xoopsDB->prefix('xoonips_item_basic');
	$tab3 = $xoopsDB->prefix('users');
	$tab4 = $xoopsDB->prefix('xoonips_item_type');
	$sql  = "SELECT t1.item_id, t2.title, t3.name, t3.uname, t4.display_name, count(t1.event_type_id) AS cnt ";
	$sql .= "FROM ".$tab1." AS t1, ".$tab2." AS t2, ".$tab3." AS t3, ".$tab4." AS t4 ";
	$sql .= "WHERE t1.event_type_id = ".$event_type_id." and t1.timestamp between ".$start_time." and ".$end_time." ";
	$sql .= "and t1.item_id = t2.item_id and t2.uid = t3.uid and t2.item_type_id = t4.item_type_id and t2.item_type_id > 1 ";
	$sql .= "group by t1.item_id order by cnt DESC";
	$res = $xoopsDB->query($sql);
		if ($res == FALSE){
			echo "ERROR: " . $xoopsDB->error();
			return RES_DB_QUERY_ERROR;
		}
	$arr = array();
	while($row = $xoopsDB->fetchArray($res)){
		$ar['item_id']      = $row['item_id'];
		$ar['title']        = $row['title'];
		$ar['name']         = $row['name'];
		$ar['uname']        = $row['uname'];
		$ar['display_name'] = $row['display_name'];
		$ar['cnt']          = $row['cnt'];
		$arr[] = $ar;
	}
	return $arr;
}

function xnpGetEventDlItemMonths($event_type_id, &$arr_mon, $start_time=0, $end_time=0)
{
	global $xoopsDB;
	$event_type_id = (int)$event_type_id;
	$start_time = (int)$start_time;
	$end_time = (int)$end_time;
	
	$tab1 = $xoopsDB->prefix('xoonips_event_log');
	$tab2 = $xoopsDB->prefix('xoonips_item_basic');
	$tab3 = $xoopsDB->prefix('users');
	$tab4 = $xoopsDB->prefix('xoonips_item_type');
	$sql  = "SELECT t1.item_id, from_unixtime(t1.timestamp, '%Y-%m') as event_mdate, count(t1.event_type_id) AS cnt ";
	$sql .= "FROM ".$tab1." AS t1, ".$tab2." AS t2, ".$tab3." AS t3, ".$tab4." AS t4 ";
	$sql .= "WHERE t1.event_type_id = ".$event_type_id." and t1.timestamp between ".$start_time." and ".$end_time." ";
	$sql .= "and t1.item_id = t2.item_id and t2.uid = t3.uid and t2.item_type_id = t4.item_type_id and t2.item_type_id > 1 ";
	$sql .= "group by event_mdate, t1.item_id";
	$res = $xoopsDB->query($sql);
		if ($res == FALSE){
			echo "ERROR: " . $xoopsDB->error();
			return RES_DB_QUERY_ERROR;
		}
	$arr_mon = array();
	while($row = $xoopsDB->fetchArray($res)){
		$ar_mon['item_id']      = $row['item_id'];
		$ar_mon['event_mdate']  = $row['event_mdate'];
		$ar_mon['cnt']          = $row['cnt'];
		$arr_mon[] = $ar_mon;
	}
	return $arr_mon;
}

function xnpGetEventItemTitles($arr, &$arr_title)
{
	global $xoopsDB;
	$ids = array();
	foreach( $arr as $tmp ){
		foreach( $tmp as $key => $value ){
			if( $key == "item_id" ){
				$ids[] = $value;
			}
		}
	}
	$item_ids = implode(",", $ids);
	if( strlen(trim($item_ids)) == 0 ){
		$arr_title = array();
	} else {
		$tab = $xoopsDB->prefix('xoonips_item_title');
		$sql = "SELECT item_id, title FROM ".$tab." WHERE item_id IN ( ".$item_ids." ) ORDER BY item_id";
		$res = $xoopsDB->query($sql);
			if ($res == FALSE){
				echo "ERROR: " . $xoopsDB->error();
				return RES_DB_QUERY_ERROR;
			}
		$arr_title = array();
		while($row = $xoopsDB->fetchArray($res)){
			$arr_title[$row["item_id"]] = $row["title"];
		}
	}
	return $arr_title;
}

function xnpGetEventItemTypes($arr, &$arr_type)
{
	global $xoopsDB;
	$ids = array();
	foreach( $arr as $tmp ){
		foreach( $tmp as $key => $value ){
			if( $key == "item_id" ){
				$ids[] = $value;
			}
		}
	}
	$item_ids = implode(",", $ids);
	if( strlen(trim($item_ids)) == 0 ){
		$arr_type = array();
	} else {
		$tab1 = $xoopsDB->prefix('xoonips_item_basic');
		$tab2 = $xoopsDB->prefix('xoonips_item_type');
		$sql  = "SELECT t1.item_id, t2.display_name FROM ".$tab1." AS t1, ".$tab2." AS t2 ";
		$sql .= "WHERE t1.item_type_id = t2.item_type_id and t1.item_id IN ( ".$item_ids." ) ORDER BY t1.item_id";
		$res = $xoopsDB->query($sql);
			if ($res == FALSE){
				echo "ERROR: " . $xoopsDB->error();
				return RES_DB_QUERY_ERROR;
			}
		$arr_type = array();
		while($row = $xoopsDB->fetchArray($res)){
			$arr_type[$row["item_id"]] = $row["display_name"];
		}
	}
	return $arr_type;
}

function xnpGetEventDlFile($event_type_id, &$arr, $start_time=0, $end_time=0)
{
	global $xoopsDB;
	$event_type_id = (int)$event_type_id;
	$start_time = (int)$start_time;
	$end_time = (int)$end_time;
	
	$tab1 = $xoopsDB->prefix('xoonips_event_log');
	$tab2 = $xoopsDB->prefix('xoonips_item_basic');
	$tab3 = $xoopsDB->prefix('users');
	$tab4 = $xoopsDB->prefix('xoonips_item_type');
	$tab5 = $xoopsDB->prefix('xoonips_file');
	$sql  = "SELECT t1.item_id, t1.file_id, t5.original_file_name, t2.title, t3.name, t3.uname, t4.display_name, count(t1.event_type_id) AS cnt ";
	$sql .= "FROM ".$tab1." AS t1, ".$tab2." AS t2, ".$tab3." AS t3, ".$tab4." AS t4, ".$tab5." AS t5 ";
	$sql .= "WHERE t1.event_type_id = ".$event_type_id." and t1.timestamp between ".$start_time." and ".$end_time." ";
	$sql .= "and t1.item_id = t2.item_id and t2.uid = t3.uid and t2.item_type_id = t4.item_type_id and t1.file_id = t5.file_id ";
	$sql .= "GROUP BY t1.file_id ORDER BY cnt DESC";
	$res = $xoopsDB->query($sql);
		if ($res == FALSE){
			echo "ERROR: " . $xoopsDB->error();
			return RES_DB_QUERY_ERROR;
		}
	$arr = array();
	while($row = $xoopsDB->fetchArray($res)){
		$ar['item_id']            = $row['item_id'];
		$ar['file_id']            = $row['file_id'];
		$ar['original_file_name'] = $row['original_file_name'];
		$ar['title']              = $row['title'];
		$ar['name']               = $row['name'];
		$ar['uname']              = $row['uname'];
		$ar['display_name']       = $row['display_name'];
		$ar['cnt']                = $row['cnt'];
		$arr[] = $ar;
	}
	return $arr;
}

function xnpGetEventDlFileMonths($event_type_id, &$arr_mon, $start_time=0, $end_time=0)
{
	global $xoopsDB;
	$event_type_id = (int)$event_type_id;
	$start_time = (int)$start_time;
	$end_time = (int)$end_time;
	
	$tab1 = $xoopsDB->prefix('xoonips_event_log');
	$tab2 = $xoopsDB->prefix('xoonips_item_basic');
	$tab3 = $xoopsDB->prefix('users');
	$tab4 = $xoopsDB->prefix('xoonips_item_type');
	$tab5 = $xoopsDB->prefix('xoonips_file');
	$sql  = "SELECT t1.file_id, from_unixtime(t1.timestamp, '%Y-%m') as event_mdate, count(t1.event_type_id) AS cnt ";
	$sql .= "FROM ".$tab1." AS t1, ".$tab2." AS t2, ".$tab3." AS t3, ".$tab4." AS t4, ".$tab5." AS t5 ";
	$sql .= "WHERE t1.event_type_id = ".$event_type_id." and t1.timestamp between ".$start_time." and ".$end_time." ";
	$sql .= "and t1.item_id = t2.item_id and t2.uid = t3.uid and t2.item_type_id = t4.item_type_id and t1.file_id = t5.file_id ";
	$sql .= "group by event_mdate, t1.file_id";
	$res = $xoopsDB->query($sql);
		if ($res == FALSE){
			echo "ERROR: " . $xoopsDB->error();
			return RES_DB_QUERY_ERROR;
		}
	$arr_mon = array();
	while($row = $xoopsDB->fetchArray($res)){
		$ar_mon['file_id']      = $row['file_id'];
		$ar_mon['event_mdate']  = $row['event_mdate'];
		$ar_mon['cnt']          = $row['cnt'];
		$arr_mon[] = $ar_mon;
	}
	return $arr_mon;
}

function xnpGetEventDlUser($event_type_id, &$arr, $start_time=0, $end_time=0)
{
	global $xoopsDB;
	$event_type_id = (int)$event_type_id;
	$start_time = (int)$start_time;
	$end_time = (int)$end_time;
	
	$tab1 = $xoopsDB->prefix('xoonips_event_log');
	$tab2 = $xoopsDB->prefix('users');
	$sql  = "SELECT case when isnull(uname) then concat(\"guest[\",remote_host,\"]\") else uname end AS uu, count(event_type_id) AS cnt ";
	$sql .= "FROM ".$tab1." left join ".$tab2." on exec_uid = ".$tab2.".uid ";
	$sql .= "WHERE event_type_id = ".$event_type_id." and timestamp between ".$start_time." and ".$end_time." ";
	$sql .= "GROUP BY uu ORDER BY cnt DESC";
	$res = $xoopsDB->query($sql);
		if ($res == FALSE){
			echo "ERROR: " . $xoopsDB->error();
			return RES_DB_QUERY_ERROR;
		}
	$arr = array();
	while($row = $xoopsDB->fetchArray($res)){
		$ar['uu']    = $row['uu'];
		$ar['cnt']   = $row['cnt'];
		$arr[] = $ar;
	}
	return $arr;
}

function xnpGetEventDlUserMonths($event_type_id, &$arr_mon, $start_time=0, $end_time=0)
{
	global $xoopsDB;
	$event_type_id = (int)$event_type_id;
	$start_time = (int)$start_time;
	$end_time = (int)$end_time;
	
	$tab1 = $xoopsDB->prefix('xoonips_event_log');
	$tab2 = $xoopsDB->prefix('users');
	$sql  = "SELECT case when isnull(uname) then concat(\"guest[\",remote_host,\"]\") else uname end AS uu, ";
	$sql .= "from_unixtime(timestamp, '%Y-%m') as event_mdate, count(event_type_id) AS cnt ";
	$sql .= "FROM ".$tab1." left join ".$tab2." on exec_uid = ".$tab2.".uid ";
	$sql .= "WHERE event_type_id = ".$event_type_id." and timestamp between ".$start_time." and ".$end_time." ";
	$sql .= "group by event_mdate, uu";
	$res = $xoopsDB->query($sql);
		if ($res == FALSE){
			echo "ERROR: " . $xoopsDB->error();
			return RES_DB_QUERY_ERROR;
		}
	$arr_mon = array();
	while($row = $xoopsDB->fetchArray($res)){
		$ar_mon['uu']          = $row['uu'];
		$ar_mon['event_mdate'] = $row['event_mdate'];
		$ar_mon['cnt']         = $row['cnt'];
		$arr_mon[] = $ar_mon;
	}
	return $arr_mon;
}

function xnpGetEventAccessUser($event_type_id, &$arr, $start_time=0, $end_time=0)
{
	global $xoopsDB;
	$event_type_id = (int)$event_type_id;
	$start_time = (int)$start_time;
	$end_time = (int)$end_time;
	
	$tab1 = $xoopsDB->prefix('xoonips_event_log');
	$tab2 = $xoopsDB->prefix('users');
	$sql  = "SELECT case when isnull(uname) then concat(\"guest[\",remote_host,\"]\") else uname end AS uu, ";
	$sql .= "count(event_type_id) AS cnt ";
	$sql .= "FROM ".$tab1." left join ".$tab2." on exec_uid = ".$tab2.".uid ";
	$sql .= "WHERE event_type_id = ".$event_type_id." and timestamp between ".$start_time." and ".$end_time." ";
	$sql .= "group by uu order by cnt DESC";
	$res = $xoopsDB->query($sql);
		if ($res == FALSE){
			echo "ERROR: " . $xoopsDB->error();
			return RES_DB_QUERY_ERROR;
		}
	$arr = array();
	while($row = $xoopsDB->fetchArray($res)){
		$ar['uu' ] = $row['uu' ];
		$ar['cnt'] = $row['cnt'];
		$arr[] = $ar;
	}
	return $arr;
}

function xnpGetEventAccessUserMonths($event_type_id, &$arr_mon, $start_time=0, $end_time=0)
{
	global $xoopsDB;
	$event_type_id = (int)$event_type_id;
	$start_time = (int)$start_time;
	$end_time = (int)$end_time;
	
	$tab1 = $xoopsDB->prefix('xoonips_event_log');
	$tab2 = $xoopsDB->prefix('users');
	$sql  = "SELECT case when isnull(uname) then concat(\"guest[\",remote_host,\"]\") else uname end AS uu, ";
	$sql .= "from_unixtime(timestamp, '%Y-%m') as event_mdate, count(event_type_id) AS cnt ";
	$sql .= "FROM ".$tab1." left join ".$tab2." on exec_uid = ".$tab2.".uid ";
	$sql .= "WHERE event_type_id = ".$event_type_id." and timestamp between ".$start_time." and ".$end_time." ";
	$sql .= "group by event_mdate, uu";
	$res = $xoopsDB->query($sql);
		if ($res == FALSE){
			echo "ERROR: " . $xoopsDB->error();
			return RES_DB_QUERY_ERROR;
		}
	$arr_mon = array();
	while($row = $xoopsDB->fetchArray($res)){
		$ar_mon['uu']    = $row['uu'];
		$ar_mon['event_mdate'] = $row['event_mdate'];
		$ar_mon['cnt']         = $row['cnt'];
		$arr_mon[] = $ar_mon;
	}
	return $arr_mon;
}

function xnpGetEventAccessUserItems($event_type_id, &$arr_item, $start_time=0, $end_time=0)
{
	global $xoopsDB;
	$event_type_id = (int)$event_type_id;
	$start_time = (int)$start_time;
	$end_time = (int)$end_time;
	
	$tab1 = $xoopsDB->prefix('xoonips_event_log');
	$tab2 = $xoopsDB->prefix('users');
	$sql  = "SELECT item_id, case when isnull(uname) then concat(\"guest[\",remote_host,\"]\") else uname end AS uu, ";
	$sql .= "count(event_type_id) AS cnt ";
	$sql .= "FROM ".$tab1." left join ".$tab2." on exec_uid = ".$tab2.".uid ";
	$sql .= "WHERE event_type_id = ".$event_type_id." and timestamp between ".$start_time." and ".$end_time." ";
	$sql .= "group by uu, item_id order by cnt DESC";
	$res = $xoopsDB->query($sql);
		if ($res == FALSE){
			echo "ERROR: " . $xoopsDB->error();
			return RES_DB_QUERY_ERROR;
		}
	$arr = array();
	while($row = $xoopsDB->fetchArray($res)){
		$ar['item_id'] = $row['item_id'];
		$ar['uu'     ] = $row['uu'     ];
		$ar['cnt'    ] = $row['cnt'    ];
		$arr_item[] = $ar;
	}
	return $arr_item;
}

function xnpGetEventAccessUserItemsMonths($event_type_id, &$arr_itemmon, $start_time=0, $end_time=0)
{
	global $xoopsDB;
	$event_type_id = (int)$event_type_id;
	$start_time = (int)$start_time;
	$end_time = (int)$end_time;
	
	$tab1 = $xoopsDB->prefix('xoonips_event_log');
	$tab2 = $xoopsDB->prefix('users');
	$sql  = "SELECT item_id, case when isnull(uname) then concat(\"guest[\",remote_host,\"]\") else uname end AS uu, ";
	$sql .= "from_unixtime(timestamp, '%Y-%m') as event_mdate, count(event_type_id) AS cnt ";
	$sql .= "FROM ".$tab1." left join ".$tab2." on exec_uid = ".$tab2.".uid ";
	$sql .= "WHERE event_type_id = ".$event_type_id." and timestamp between ".$start_time." and ".$end_time." ";
	$sql .= "group by event_mdate, uu, item_id";
	$res = $xoopsDB->query($sql);
		if ($res == FALSE){
			echo "ERROR: " . $xoopsDB->error();
			return RES_DB_QUERY_ERROR;
		}
	$arr_mon = array();
	while($row = $xoopsDB->fetchArray($res)){
		$ar_imon['item_id']     = $row['item_id'];
		$ar_imon['uu']          = $row['uu'];
		$ar_imon['event_mdate'] = $row['event_mdate'];
		$ar_imon['cnt']         = $row['cnt'];
		$arr_itemmon[] = $ar_imon;
	}
	return $arr_itemmon;
}


/*
 *
 * function for downloads
 *
 */
function xnpLogDays($arr, $start_time, $end_time){
	// Prepare for days
	$tmp_days = $end_time - $start_time;
	$days = $tmp_days / 86400;

	$tt = '';
	$label = '';
	for($i = 0; $i < $days; $i++){
		$tt = $start_time + 86400 * $i;
		$label = date("Y-m-d", $tt);
		if( array_key_exists($label, $arr) ){
			echo $label.",".$arr[$label]."\r\n";
		} else {
			echo $label.",0"."\r\n";
		}
	}
	exit;
}

function xnpLogDaysTotal($arr, $start_time, $end_time){
	// Prepare for days
	$tmp_days = $end_time - $start_time;
	$days = $tmp_days / 86400;

	$tt = '';
	$label = '';
	$show = 0;
	for($i = 0; $i < $days; $i++){
		$tt = $start_time + 86400 * $i;
		$label = date("Y-m-d", $tt);
		if( array_key_exists($label, $arr) ){
			$show = $show + $arr[$label];
			echo $label.",".$show."\r\n";
		} else {
			echo $label.",".$show."\r\n";
		}
	}
	exit;
}

function xnpLogMonths($arr, $st_year, $st_month, $en_year, $en_month, $start_time, $end_time){
	$label_m = array("01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12");

	// calc months
	$years = $en_year - $st_year;
	if( $years <= 0 ){
		$months = $en_month - $st_month;
	} else {
		$mon = 12 * $years;
		$months = $en_month - $st_month + $mon ;
	}
	
	$res = array();
	$la_year = '';
	$show = '';
	for( $i = 0; $i < $months; $i++){
		$la_month = $st_month + $i - 1;
		$la = $la_month % 12;
		if( empty($la_year) ){
			$la_year = $st_year;
		} elseif( $la_month > 11 && $la == 0 ){
			$la_year++;
		}
		$label = $la_year . "-" . $label_m[$la];
		if( array_key_exists($label, $arr) ){
			echo $label.",".$arr[$label]."\r\n";
		} else {
			echo $label.",0"."\r\n";
		}
	}
	exit;
}

function checkIP($ip){
	$ip2 = long2ip(ip2long($ip));
	if($ip == $ip2){
		return true;
	} else {
		return false;
	}
}

function xnpLogDomains($arr){
	$res = array();
	foreach( $arr as $unknown => $num ){
		if( preg_match( "/.([0-9]{1,3})/", $unknown ) !== 1 ){
			$tmp   = explode(".", $unknown);
			$tl_domain = end($tmp);
		} else {
			if( checkIP($unknown) == false ){
				echo "ip address error";
			}
		$host  = gethostbyaddr($unknown);
		$tmp   = explode(".", $host);
		$tl_domain = end($tmp);
			if( preg_match("/([0-9]{1,3})/", $tl_domain) == 1 ){
				$tl_domain = "unknown";
			}
		}
		if( !array_key_exists( $tl_domain, $res ) ){
			$res[$tl_domain] = intval($num);
		} else {
			$b_num = $res[$tl_domain];
			$res[$tl_domain] = $b_num + $num;
		}
	}

	arsort($res, SORT_NUMERIC);

	foreach( $res as $showkey => $showvalue){
		echo $showkey.",".$showvalue."\r\n";
	}
	exit;
}

function xnpLogLabelMonths($log_type_id, &$arr, $st_year, $st_month, $en_year, $en_month, $start_time, $end_time){
	$label_m = array("01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12");

	// calc months
	$years = $en_year - $st_year;
	if( $years <= 0 ){
		$months = $en_month - $st_month;
	} else {
		$mon = 12 * $years;
		$months = $en_month - $st_month + $mon ;
	}
	
	$res = array();
	$la_year = '';
	$arr = '';
	switch($log_type_id){
		case 15:
			$arr = _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DL_PER_ITEM;
			break;
		case 16:
			$arr = _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DL_PER_FILE;
			break;
		case 17:
			$arr = _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_DL_PER_USER;
			break;
		case 18:
			$arr = _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_ACCESS_ITEM;
			break;
		case 19:
			$arr = _MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_ACCESS_USER;
			break;
		default:	
	}
	for( $i = 0; $i < $months; $i++){
		$la_month = $st_month + $i - 1;
		$la = $la_month % 12;
		if( empty($la_year) ){
			$la_year = $st_year;
		} elseif( $la_month > 11 && $la == 0 ){
			$la_year++;
		}
		$label = $la_year . "-" . $label_m[$la];
		$arr = $arr.$label.",";
	}
	$arr = $arr._MI_XOONIPS_EVENT_LOG_EVENT_COLUMNS_TOTAL;
	return $arr;
}

function dquote($str)
	{
		return '"' . str_replace( '"', '""', $str ) . '"';
	}

function xnpLogDlItem($arr1, $arr2, $arr3, $range){
	$ranran = explode(",", $range);
	foreach( $ranran as $key => $value ){
		if( preg_match("/-/", $value ) == 1 ){
			$ran[] = $value;
		}
	}
	foreach( $arr1 as $show ){
		$monthstr = '';
		
		$item_id      = isset($show["item_id"     ]) ? $show["item_id"] : '';
		if( strlen(trim($show["title"])) !== 0 ){
			$title   = dquote($show["title"]);
		} else {
			$title   = dquote($arr3[$item_id]);
		}
		if( strlen(trim($show["name"])) !== 0 ){
			$name    = dquote($show["name" ]);
		} else {
			$name    = dquote($show["uname"]);
		}
		
		$display_name = isset($show["display_name"]) ? dquote($show["display_name"]) : '';
		
		$ran_cnt = count($ran);
		$monthcnt = array();
		for( $i = 0; $i < $ran_cnt; $i++ ){
			$cnt2 = '';
			foreach( $arr2 as $show2 ){
				if( $ran[$i] == $show2["event_mdate"] && $item_id == $show2["item_id"] ){
						$cnt2 = $show2["cnt"];
				}
			}
			if( !$cnt2 ){
				$cnt2 = '';
			}
			$monthcnt[] = $cnt2;
		}
		$monthstr = implode(",", $monthcnt);
		
		$cnt          = isset($show["cnt"         ]) ? $show["cnt"    ] : '';
		echo "$item_id,$title,$name,$display_name,$monthstr,$cnt\r\n";
	}
	exit;
}

function xnpLogDlFile($arr1, $arr2, $arr3, $range){
	$ranran = explode(",", $range);
	foreach( $ranran as $key => $value ){
		if( preg_match("/-/", $value ) == 1 ){
			$ran[] = $value;
		}
	}
	foreach( $arr1 as $show ){
		$item_id            = isset($show["item_id"           ]) ? $show["item_id"] : '';
		$file_id            = isset($show["file_id"           ]) ? $show["file_id"] : '';
		$original_file_name = isset($show["original_file_name"]) ? dquote($show["original_file_name"]) : '';
		if( strlen(trim($show["title"])) !== 0 ){
			$title    = dquote($show["title"]);
		} else {
			$title    = dquote($arr3[$item_id]);
		}
		if( strlen(trim($show["name"])) !== 0 ){
			$name    = dquote($show["name" ]);
		} else {
			$name    = dquote($show["uname"]);
		}
		$display_name       = isset($show["display_name"      ]) ? dquote($show["display_name"]) : '';

		$ran_cnt = count($ran);
		$monthcnt = array();
		for( $i = 0; $i < $ran_cnt; $i++ ){
			$cnt2 = '';
			foreach( $arr2 as $show2 ){
				if( $ran[$i] == $show2["event_mdate"] && $file_id == $show2["file_id"] ){
						$cnt2 = $show2["cnt"];
				}
			}
			if( !$cnt2 ){
				$cnt2 = '';
			}
			$monthcnt[] = $cnt2;
		}
		$monthstr = implode(",", $monthcnt);
		
		$cnt          = isset($show["cnt"         ]) ? $show["cnt"    ] : '';
		echo "$file_id,$original_file_name,$title,$name,$display_name,$monthstr,$cnt\r\n";
	}
	exit;
}

function xnpLogEventLabelDomains($arr, &$arr_dom){
	$arr_doms = array();
	$ids = array();
	$doms = array();
	foreach( $arr as $tmp ){
		foreach( $tmp as $key =>$value ){
			if( $key == "exec_uid" ){
				$ids[] = $value;
			} elseif( $key == "remote_host" ){
				if( preg_match( "/.([0-9]{1,3})/", $value ) !== 1 ){
					$doms[] = $value;
				} else {
					if( checkIP($value) == false ){
						$doms[] = "unknown";
					}
					$host = gethostbyaddr($value);
					$doms[] = $value;
				}
			} else {
				$doms[] = '';
			}
		}
	}
	
	$cnt = count($ids);
	for($i = 0; $i < $cnt; $i++ ){
		$arr_dom[$i] = array( "exec_uid" => $ids[$i], "remote_host" => $doms[$i] );
	}
	return $arr_dom;
}

function xnpLogDlUser($arr1, $arr2, $arr3, $range){
	$ranran = explode(",", $range);
	foreach( $ranran as $key => $value ){
		if( preg_match("/-/", $value ) == 1 ){
			$ran[] = $value;
		}
	}
	foreach( $arr1 as $show ){
		$uu    = isset($show["uu"]) ? $show["uu"] : '';
		$ran_cnt = count($ran);
		$monthcnt = array();
		for( $i = 0; $i < $ran_cnt; $i++ ){
			$cnt2 = '';
			foreach( $arr2 as $show2 ){
				if( $uu == $show2["uu"] ){
					if( $ran[$i] == $show2["event_mdate"] ){
						$cnt2 = $show2["cnt"];
					}
				}
			}
			if( !$cnt2 ){
				$cnt2 = '';
			}
			$monthcnt[] = $cnt2;
		}
		$monthstr = implode(",", $monthcnt);
		
		$cnt          = isset($show["cnt"         ]) ? $show["cnt"    ] : '';
		echo "$uu,$monthstr,$cnt\r\n";
	}
	exit;
}

function xnpLogAccessUser($arr1, $arr2, $arr3, $arr4, $arr5, $arr6, $arr7, $range){
	$ranran = explode(",", $range);
	foreach( $ranran as $key => $value ){
		if( preg_match("/-/", $value ) == 1 ){
			$ran[] = $value;
		}
	}
	
	foreach( $arr1 as $show ){
		$uu = isset($show["uu"]) ? ($show["uu"]) : '';
		$cnt = isset($show["cnt"]) ? $show["cnt"] : '';
		$ran_cnt = count($ran);
		$monthcnt = array();
		for( $i = 0; $i < $ran_cnt; $i++ ){
			$cnt2 = '';
			foreach( $arr2 as $show2 ){
				if( $uu == $show2["uu"] ){
					if( $ran[$i] == $show2["event_mdate"] ){
						$cnt2 = $show2["cnt"];
					}
				}
			}
			if( !$cnt2 ){
				$cnt2 = '';
			}
			$monthcnt[] = $cnt2;
		}
		$monthstr = implode(",", $monthcnt);
		echo "$uu,,,$monthstr,$cnt\r\n";
		
		// per item
		foreach( $arr5 as $show3 ){
			if( $uu == $show3['uu'] ){
				$item_id = isset($show3["item_id"]) ? $show3["item_id"] : '';
				if( array_key_exists($item_id, $arr3) ){
					$title = dquote($arr3[$item_id]);
				} else {
					$title = "item_id : " . $item_id;
				}
				if( array_key_exists($item_id, $arr7) ){
					$display_name = dquote($arr7[$item_id]);
				} else {
					$display_name = '';
				}
				$itemmonthcnt = array();
				for( $j = 0; $j < $ran_cnt; $j++ ){
					$cnt_mon = '';
					foreach( $arr6 as $show4 ){
						if( $ran[$j] == $show4["event_mdate"] ){
							if( $item_id == $show4["item_id"]  && $uu == $show4["uu"] ){
									$cnt_mon = $show4["cnt"];
							}
						}
					}
					if( !$cnt_mon ){
						$cnt_mon = '';
					}
					$itemmonthcnt[] = $cnt_mon;
				}
				$itemmonthstr = implode(",", $itemmonthcnt);
				$itemcnt = isset($show3["cnt"]) ? $show3["cnt"] : '';
				echo ",$title,$display_name,$itemmonthstr,$itemcnt\r\n";
			}
		}
	}
	exit;
}

function xnpListDlRegiUser($xnpsid){
	global $xoopsDB;
	$xoonips_uids = array();
	$xoonips_users = array();
	xnp_dump_uids( $xnpsid, array(), $xoonips_uids );
	xnp_get_accounts( $xnpsid, $xoonips_uids, array(), $xoonips_users );
	foreach ($xoonips_users as $u) {
		$uname    = dquote(htmlspecialchars($u['uname'], ENT_QUOTES));
		$com_name = dquote(htmlspecialchars($u['company_name'], ENT_QUOTES));
		$div_name = dquote(htmlspecialchars($u['division'], ENT_QUOTES));
		$eml_name = dquote(htmlspecialchars($u['email'], ENT_QUOTES));
		echo $uname.",".$com_name.",".$div_name.",".$eml_name."\r\n";
	}
	exit;
}

function xnpListDlRegiItem($xnpsid){
	global $xoopsDB;

	$xoonips_item_ids = array();
	$xoonips_items = array();
	xnp_dump_item_id( $xnpsid, array(), $xoonips_item_ids );
	xnp_get_items( $xnpsid, $xoonips_item_ids, array(), $xoonips_items );
	foreach ($xoonips_items as $its) {
		$itid = intval($its['item_id']);
		$title = dquote(htmlspecialchars($its['title'], ENT_QUOTES));
		$type  = isset($its["item_type_id"]) ? $its["item_type_id"] : '';
		$itemtypes = array();
		if( xnp_get_item_types( $itemtypes ) != RES_OK ){
			redirect_header('index.php', 3, "ERROR xnp_get_item_types [AbstractLayer]".xnp_get_last_error_string());
			break;
		} else {
			foreach( $itemtypes as $i ){
				if( $i['item_type_id'] == $type ){
					$itemtype = $i;
					$modname = dquote(htmlspecialchars($itemtype['display_name'], ENT_QUOTES));
					break;
				}
			}
		}
		$uid   = intval($its['uid']);
		$user = array();
		xnp_get_account($xnpsid, $uid, $user);
		$con_name = $user['uname'];
		echo $itid.",".$title.",".$modname.",".$con_name."\r\n";
	}
	exit;
}

function &loggraph_utf8_encode( $text ) {
  if ( XOOPS_USE_MULTIBYTES == 1 ) {
    if ( function_exists( 'mb_convert_encoding' ) ) {
      $encode = mb_detect_encoding( $text );
      if ( $encode != 'UTF-8' ) {
        $ret = mb_convert_encoding( $text, 'UTF-8', $encode );
        return $ret;
      } else {
        return $text;
      }
    } else {
      return $text;
    }
  }
  $ret = utf8_encode( $text );
  return $ret;
}

function loggraph_draw( &$xdata, &$ydata, $title, $xlabel, $mode  ) {
  // load graph library
  include_once dirname(dirname(__FILE__)).'/class/base/graph.class.php';

  // count number of data
  $num = count( $ydata );

  // create graph object
  $xgraph = new XooNIpsGraph( 500, 400 );

  // initilize parameters
  $xgraph->setLanguage( $GLOBALS['xoopsConfig']['language'] );
  $xgraph->setAxisGrid( 'x', 'none' );
  $xgraph->setAxisGridLines( 'y', 6 );
  $xgraph->frame->setType( 'axis' );
  $xgraph->setTitle( loggraph_utf8_encode( $title ) );
  $xgraph->axis['bottom']->setLabel( loggraph_utf8_encode( $xlabel ) );

  switch ( $mode ) {
  case 'months':
    // hide x ticks
    if ( $num > 24 ) {
      $xgraph->setAxisTicksColor( 'x', 'none' );
    }
    // rotate x tick labels
    if ( $num > 6 ) {
      $xgraph->setAxisAngle( 'x', 60 );
    }
    // set x tick interval
    if ( $num < 24 ) {
      $xinterval = 1;
    } else if ( $num < 60 ) {
      $xinterval = 4;
    } else {
      $xinterval = 12;
    }
    $xgraph->axis['bottom']->setTickInterval( $xinterval );
    // create y data
    $xgraph_data = new XooNIpsGraphDataBar( $ydata );
    $xgraph_data->setBarSize( 0.5 );
    $xgraph->setXAxisOffset( 0.5 );
    $xgraph_data->setColor( 'red' );
    break;
  case 'days':
    // hide x ticks
    if ( $num > 70 ) {
      $xgraph->setAxisTicksColor( 'x', 'none' );
    }
    // rotate x tick labels
    if ( $num > 130 ) {
      $xgraph->setAxisAngle( 'x', 60 );
    }
    // set x tick interval
    if ( $num < 32 ){
      $xinterval = 3;
    } else if( $num < 70 ) {
      $xinterval = 5;
    } else {
      $xinterval = 1;
    }
    $xgraph->axis['bottom']->setTickInterval( $xinterval );
    // create y data
    $xgraph_data = new XooNIpsGraphDataLine( $ydata );
    $xgraph_data->setColor( 'blue' );
    $xgraph_data->setShadowColor( 'none' );
    break;
  case 'domains':
    // create y data
    $xgraph_data = new XooNIpsGraphDataBar( $ydata );
    $xgraph_data->setBarSize( 0.5 );
    $xgraph->setXAxisOffset( 0.5 );
    $xgraph_data->setColor( 'green' );
    break;
  }

  // set x tick labels
  $xgraph->setXData( $xdata );

  // add y data and set prefered maximum/minimum y axis range
  $xgraph->addYData( $xgraph_data );
  $xgraph->setPreferedYAxisRange();

  // draw
  $xgraph->draw();
}

function loggraph_draw_days_graph( &$arr, $start_time, $end_time, $title, $xlabel, $is_total ) {
  // prepare for days
  $a_day = 86400;
  $days = ( $end_time - $start_time ) / $a_day;

  // create access log of all days from $arr variable
  $ydata = array();
  $xdata = array();
  $amount = 0;
  for ( $i = 0; $i < $days; $i++ ) {
    $access_day = $start_time + $a_day * $i;
    $day = date( "d", $access_day );
    $month = date( "m", $access_day );
    $year = date( "Y", $access_day );
    $log_key = $year.'-'.$month.'-'.$day;
    // get access count if given.
    $count = ( array_key_exists( $log_key, $arr ) ) ? $arr[$log_key] : 0;
    $amount += intval( $count );
    // create x label
    if ( $days < 70 ) {
      $day_label = strval( intval( $day ) );
    } else if ( $days < 190 ) {
      if ( $day == '01' ) {
        $day_label = $year.'.'.$month;
      } else {
        $day_label = '';
      }
    } else {
      if ( $day == '01' && ( ( intval( $month ) % 3 == 1 ) ) ) {
        $day_label = $year.'.'.$month;
      } else {
        $day_label = '';
      }
    }
    // set data
    $xdata[] = $day_label;
    $ydata[] = ( $is_total ) ? $amount : $count;
  }
  loggraph_draw( $xdata, $ydata, $title, $xlabel, 'days' );
}

function loggraph_draw_months_graph( &$arr, $start_time, $end_time, $title, $xlabel, $is_total ) {
  // get each day, month, year 
  $start = array (
    'month' => intval( date( "m", $start_time ) ),
    'year' => intval( date( "Y", $start_time ) )
  );
  $end = array (
    'month' => intval( date( "m", $end_time ) ),
    'year' => intval( date( "Y", $end_time ) )
  );

  $month_arr = array( '01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12' );

  // calc months
  $years = $end['year'] - $start['year'];
  if( $years <= 0 ){
    $months = $end['month'] - $start['month'] + 1;
  } else {
    $months = $end['month'] - $start['month'] + 1 + $years * 12;
  }
  $ydata = array();
  $xdata = array();
  $amount = 0;
  for ( $i = 0; $i < $months; $i++ ) {
    $tmp = $start['month'] + $i - 1;
    $month = ( $tmp % 12 ) + 1;
    $year = $start['year'] + intval( $tmp / 12 );
    // create x label
    $month_label = $year.'-'.$month_arr[$month - 1];
    // get access count if given.
    if( array_key_exists($month_label, $arr) ){
      $count = $arr[$month_label];
    } else {
      $count = 0;
    }
    $amount += $count;

    $xdata[] = $month_label;
    $ydata[] = ( $is_total ) ? $amount : $count;
  }
  loggraph_draw( $xdata, $ydata, $title, $xlabel, 'months' );
}

function loggraph_draw_domains_graph( &$arr, $title, $xlabel ) {
  $res = array();
  foreach( $arr as $unknown => $num ){
    if( preg_match( "/.([0-9]{1,3})/", $unknown ) !== 1 ){
      $tmp   = explode(".", $unknown);
      $tl_domain = end($tmp);
    } else {
      if( checkIP($unknown) == false ){
        echo "ip address error";
      }
      $host  = gethostbyaddr($unknown);
      $tmp   = explode(".", $host);
      $tl_domain = end($tmp);
      if( preg_match("/([0-9]{1,3})/", $tl_domain) == 1 ){
        $tl_domain = "unknown";
      }
    }
    if( !array_key_exists( $tl_domain, $res ) ){
      $res[$tl_domain] = intval($num);
    } else {
      $b_num = $res[$tl_domain];
      $res[$tl_domain] = $b_num + $num;
    }
  }
  arsort($res, SORT_NUMERIC);
  $gdata = array();
  foreach( $res as $showkey => $showvalue){
    $gdata[$showkey] = $showvalue;
  }
  $ydata = array();
  $xdata = array();
  foreach( $gdata as $date => $value ){
    $xdata[] = $date;
    $ydata[] = $value;
  }
  loggraph_draw( $xdata, $ydata, $title, $xlabel, 'domains' );
}

function xnpLogDaysLineGraph( $arr, $start_time, $end_time, $type_id, $type_name, $datelabel ) {
  $title_arr = array (
    1 => _MI_XOONIPS_EVENT_LOG_ACCESS_TOP_DAYS_TITLE,
    5 => _MI_XOONIPS_EVENT_LOG_ACCESS_ITEM_DAYS_TITLE,
    9 => _MI_XOONIPS_EVENT_LOG_DL_ITEM_DAYS_TITLE
  );
  $title = '';
  if ( array_key_exists( $type_id, $title_arr ) ) {
    $title = $title_arr[$type_id];
  }
  $xlabel = $datelabel.' ['._MI_XOONIPS_EVENT_LOG_DAYS_LABEL.']';
  loggraph_draw_days_graph( $arr, $start_time, $end_time, $title, $xlabel, false );
}

function xnpLogDaysTotalLineGraph( $arr, $start_time, $end_time, $type_id, $type_name, $datelabel ) {
  $title_arr = array (
    3 => _MI_XOONIPS_EVENT_LOG_ACCESS_TOP_DAYS_TOTAL_TITLE,
    7 => _MI_XOONIPS_EVENT_LOG_ACCESS_ITEM_DAYS_TOTAL_TITLE,
    11 => _MI_XOONIPS_EVENT_LOG_DL_ITEM_DAYS_TOTAL_TITLE
  );
  $title = '';
  if ( array_key_exists( $type_id, $title_arr ) ) {
    $title = $title_arr[$type_id];
  }
  $xlabel = $datelabel.' ['._MI_XOONIPS_EVENT_LOG_DAYS_LABEL.']';
  loggraph_draw_days_graph( $arr, $start_time, $end_time, $title, $xlabel, true );
}

function xnpLogMonthsBarGraph($arr, $st_year, $st_month, $en_year, $en_month, $start_time, $end_time, $type_id, $type_name, $datelabel ) {
  $title_arr = array (
    2 => _MI_XOONIPS_EVENT_LOG_ACCESS_TOP_MONTHS_TITLE,
    6 => _MI_XOONIPS_EVENT_LOG_ACCESS_ITEM_MONTHS_TITLE,
    10 => _MI_XOONIPS_EVENT_LOG_DL_ITEM_MONTHS_TITLE,
    13 => _MI_XOONIPS_EVENT_LOG_NEW_USER_MONTHS_TITLE,
    14 => _MI_XOONIPS_EVENT_LOG_NEW_ITEM_MONTHS_TITLE
  );
  $title = '';
  if ( array_key_exists( $type_id, $title_arr ) ) {
    $title = $title_arr[$type_id];
  }

  $xlabel = $datelabel.' ['._MI_XOONIPS_EVENT_LOG_MONTHS_LABEL.']';
  loggraph_draw_months_graph( $arr, $start_time, $end_time, $title, $xlabel, false );
}

function xnpLogDomainsBarGraph( $arr, $type_id, $type_name, $datelabel ){
  $title_arr = array (
    4 => _MI_XOONIPS_EVENT_LOG_ACCESS_TOP_DOMAINS_TITLE,
    8 => _MI_XOONIPS_EVENT_LOG_ACCESS_ITEM_DOMAINS_TITLE,
    12 => _MI_XOONIPS_EVENT_LOG_DL_ITEM_DOMAINS_TITLE
  );
  $title = '';
  if ( array_key_exists( $type_id, $title_arr ) ) {
    $title = $title_arr[$type_id];
  }
  $xlabel = $datelabel.' ['._MI_XOONIPS_EVENT_LOG_DOMAINS_LABEL.']';
  loggraph_draw_domains_graph( $arr, $title, $xlabel );
}

/*
 *
 * function for view
 *
 */

function xnpListViewRegiUser($xnpsid, $cri){
	global $xoopsDB;
	$xoonips_uids = array();
	$xoonips_users = array();
	xnp_dump_uids( $xnpsid, $cri, $xoonips_uids );
	xnp_get_accounts( $xnpsid, $xoonips_uids, array(), $xoonips_users );
	foreach ($xoonips_users as $u) {
		$ar['uid']      = intval($u['uid']);
		$ar['uname']    = htmlspecialchars($u['uname'], ENT_QUOTES);
		$ar['com_name'] = htmlspecialchars($u['company_name'], ENT_QUOTES);
		$ar['div_name'] = htmlspecialchars($u['division'], ENT_QUOTES);
		$ar['eml_name'] = htmlspecialchars($u['email'], ENT_QUOTES);
		$res[] = $ar;
	}
	return $res;
}

function xnpListViewRegiItem($xnpsid, $cri){
	global $xoopsDB;
	$xoonips_item_ids = array();
	$xoonips_items = array();
	xnp_dump_item_id( $xnpsid, $cri, $xoonips_item_ids );
	xnp_get_items( $xnpsid, $xoonips_item_ids, array(), $xoonips_items );
	foreach ($xoonips_items as $its) {
		$ar['item_id'] = intval($its['item_id']);
		$ar['title'] = $its['title'];
		$type  = isset($its["item_type_id"]) ? $its["item_type_id"] : '';
		$itemtypes = array();
		if( xnp_get_item_types( $itemtypes ) != RES_OK ){
			redirect_header('index.php', 3, "ERROR xnp_get_item_types [AbstractLayer]".xnp_get_last_error_string());
			break;
		} else {
			foreach( $itemtypes as $i ){
				if( $i['item_type_id'] == $type ){
					$itemtype = $i;
					$ar['mod_name'] = htmlspecialchars($itemtype['display_name'], ENT_QUOTES);
					break;
				}
			}
		}
		$uid   = intval($its['uid']);
		$user = array();
		xnp_get_account($xnpsid, $uid, $user);
		$ar['con_name'] = $user['uname'];
		$res[] = $ar;
	}
	return $res;
}

?>
