<?php
// $Revision: 1.1.2.2 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

//  Install script for moderator module

require_once XOOPS_ROOT_PATH . '/class/database/sqlutility.php';
require_once XOOPS_ROOT_PATH . '/modules/xoonips/condefs.php';
require_once XOOPS_ROOT_PATH . '/modules/xoonips/include/lib.php';
require_once XOOPS_ROOT_PATH . '/modules/xoonips/include/create_session.php';

function xoonips_get_default_configs(){
	$configs = array(
		'moderator_gid'                 => array( 'type' => 'i'  , 'value' => ''         ),
		'certify_user'                  => array( 'type' => 's'  , 'value' => 'on'       ),
		'certify_item'                  => array( 'type' => 's'  , 'value' => 'on'       ),
		'public_item_target_user'       => array( 'type' => 's'  , 'value' => 'all'      ),
		'upload_dir'                    => array( 'type' => 's'  , 'value' => ''         ),
		'account_realname_optional'     => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_address_optional'      => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_division_optional'     => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_tel_optional'          => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_company_name_optional' => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_country_optional'      => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_zipcode_optional'      => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_fax_optional'          => array( 'type' => 's'  , 'value' => 'off'      ),
		'private_item_number_limit'     => array( 'type' => 'i'  , 'value' => '100'      ),
		'private_index_number_limit'    => array( 'type' => 'i'  , 'value' => '50'       ),
		'private_item_storage_limit'    => array( 'type' => 'dm' , 'value' => '50000000' ),
		'group_item_number_limit'       => array( 'type' => 'i'  , 'value' => '300'      ),
		'group_index_number_limit'      => array( 'type' => 'i'  , 'value' => '200'      ),
		'group_item_storage_limit'      => array( 'type' => 'dm' , 'value' => '100000000'),
		'amazon_associates_id'          => array( 'type' => 's'  , 'value' => ''         ),
		'export_attachment'             => array( 'type' => 's'  , 'value' => 'off'      ),
		'export_enabled'                => array( 'type' => 's'  , 'value' => 'off'      ),
		'rss_file_path'                 => array( 'type' => 's'  , 'value' => ''         ),
		'rss_item_max'                  => array( 'type' => 'i'  , 'value' => '10'       ),
		'tree_frame_width'              => array( 'type' => 's'  , 'value' => '100%'     ),
		'tree_frame_height'             => array( 'type' => 's'  , 'value' => '400'      ),
		'printer_friendly_header'       => array( 'type' => 's'  , 'value' => ''         ),
		'repository_institution'        => array( 'type' => 's'  , 'value' => 'meta_author' ),
		'repository_publisher'          => array( 'type' => 's'  , 'value' => 'meta_author' ),
		'repository_name'               => array( 'type' => 's'  , 'value' => ''         ),
		'repository_nijc_code'          => array( 'type' => 's'  , 'value' => ''         ),
		'repository_deletion_track'     => array( 'type' => 's'  , 'value' => '30'       ),
		'download_file_compression'     => array( 'type' => 's'  , 'value' => 'on'       ),
		'item_show_optional'            => array( 'type' => 's'  , 'value' => 'off'      ),
		'private_import_enabled'        => array( 'type' => 's'  , 'value' => 'off'      ),
		'moderator_modify_any_items'    => array( 'type' => 's'  , 'value' => 'off'      ),
		'proxy_host'    => array( 'type' => 's'  , 'value' => ''      ),
		'proxy_port'    => array( 'type' => 'i'  , 'value' => '80'      ),
		'proxy_user'    => array( 'type' => 's'  , 'value' => ''      ),
		'proxy_pass'    => array( 'type' => 's'  , 'value' => ''      ),
		'magic_file_path' => array( 'type' => 's', 'value' => '/usr/share/misc/magic' ),
		'ranking_num_rows' => array( 'type' => 'i', 'value' => '5' ),
		'ranking_order' => array( 'type' => 's', 'value' => '0,1,2,3,4' ),
		'ranking_visible' => array( 'type' => 's', 'value' => '1,1,1,1,1' ),
		'ranking_new_num_rows' => array( 'type' => 'i', 'value' => '5' ),
		'ranking_new_order' => array( 'type' => 's', 'value' => '0,1' ),
		'ranking_new_visible' => array( 'type' => 's', 'value' => '1,1' ),
		'ranking_days' => array( 'type' => 'i', 'value' => '14' ),
		'ranking_days_enabled' => array( 'type' => 's', 'value' => '' ),
		'ranking_lock_timeout' => array( 'type' => 'i', 'value' => '0' ),
		'ranking_last_update' => array( 'type' => 'i', 'value' => '0' ),
		'ranking_sum_start' => array( 'type' => 'i', 'value' => '0' ),
		'ranking_sum_last_update' => array( 'type' => 'i', 'value' => '0' ),
	);
	return $configs;
}

// Unset items in xoonips_config is set.
function xoonips_insert_default_configs(){
	$configs = xoonips_get_default_configs();
	global $xoopsDB;
	$table = $xoopsDB->prefix('xoonips_config');
	foreach ( $configs as $key => $ar ){
		$escKey = addslashes( $key );
		$escVal = addslashes( $ar['value'] );
		
		$result = $xoopsDB->query( "select value from $table where name='$escKey'" );
		if ( $xoopsDB->getRowsNum($result) == 0 ){
			$result = $xoopsDB->query( "insert into $table ( name, value ) values ('$escKey', '$escVal' )" );
		}
	}
}

function xoonips_get_obsolete_configs(){
	$configs = array(
		'amazon_associates_id',
	);
	return $configs;
}

// removed obsolete configs 
function xoonips_delete_obsolete_configs(){
	$configs = xoonips_get_obsolete_configs();
	global $xoopsDB;
	$table = $xoopsDB->prefix('xoonips_config');
	foreach ( $configs as $key ){
		$escKey = addslashes( $key );
		
		$result = $xoopsDB->query( "select value from $table where name='$escKey'" );
		if ( $xoopsDB->getRowsNum($result) != 0 ){
			$result = $xoopsDB->query( "delete from $table where name='$escKey'" );
		}
	}
}

// display config in $bid blocks
function xoonips_set_block_visible( $bid, $visible ){
	$block = new XoopsBlock();
	$block->load( $bid );
	$block->setVar( 'visible', $visible ? 1 : 0 );
	$block->store();
	
	// set to display all pages
	// module_id = 0:all pages, -1:Top
	global $xoopsDB;
	if ( $visible )
		$xoopsDB->query( "insert into ".$xoopsDB->prefix('block_module_link')." (block_id, module_id) values ( $bid, 0 )" );
}

// positions
function xoonips_get_default_positions(){
	$positions = array(
		'Professor'                      => array( 'posi_order' => '10'        ),
		'Associate Professor'            => array( 'posi_order' => '20'        ),
		'Assistant Professor'            => array( 'posi_order' => '30'        ),
		'Lecturer'                       => array( 'posi_order' => '40'        ),
		'Instructor'                     => array( 'posi_order' => '50'        ),
		'Research Associate'             => array( 'posi_order' => '60'        ),
		'Research Assistant'             => array( 'posi_order' => '70'        ),
		'Assistant'                      => array( 'posi_order' => '80'        ),
		'Secretary'                      => array( 'posi_order' => '90'        ),
		'Others'                         => array( 'posi_order' => '100'       ),
		'Moderator'                      => array( 'posi_order' => '110'       ),
		'Registered Users'               => array( 'posi_order' => '120'       )
	);
	return $positions;
}

// set default positions to positions table
function xoonips_insert_default_positions(){
	$positions = xoonips_get_default_positions();
	global $xoopsDB;
	$table = $xoopsDB->prefix('xoonips_positions');
	foreach ( $positions as $key => $ar ){
		$escKey = addslashes( $key );
		$escVal = addslashes( $ar['posi_order'] );
		
		$result = $xoopsDB->query( "select posi_title from $table where posi_title='$escKey'" );
		if ( $xoopsDB->getRowsNum($result) == 0 ){
			$result = $xoopsDB->query( "insert into $table ( posi_title, posi_order ) values ('$escKey', '$escVal' )" );
		}
	}
}

function xoops_module_update_xoonips ( $xoopsMod, $oldversion) {

	global $xoopsDB;
	xoonips_insert_default_configs();

	echo "<code>Updating modules...</code><br />";
	switch ($oldversion) { //remember that version is multiplied with 100 to get an integer
	case 200:
		$sqls = <<<SQL
-- xoonips_file
ALTER TABLE xoonips_file 
	DROP INDEX sid,
	CHANGE sid `sess_id` varchar(32) default NULL,
	ADD INDEX sess_id ( sess_id ),
	ADD `search_module_name` varchar(255) default NULL,
	ADD `search_module_version` float default NULL,
	ADD header VARCHAR(32) BINARY default NULL,
	ADD timestamp TIMESTAMP;
-- xooinps_item_basic
ALTER TABLE xoonips_item_basic  DROP INDEX title,
	MODIFY title text,
	MODIFY doi blob;
-- xoonips_oaipmh_metadata
ALTER TABLE xoonips_oaipmh_metadata  ADD datestamp datetime default NULL;
-- xoonips_session
ALTER TABLE xoonips_session  DROP remote_host,
	ADD su_uid int(10) UNSIGNED default NULL,
	MODIFY uid int(10) unsigned default NULL,
	CHANGE sid sess_id varchar(32) NOT NULL default '',
	CHANGE timestamp updated timestamp AFTER sess_id;
-- xoonips_users
ALTER TABLE xoonips_users  ADD user_order smallint(3) default '0',
	ADD posi smallint(5) default '0',
	ADD appeal text default NULL;
CREATE TABLE xoonips_cvitaes   (
	cvitae_id int(11) NOT NULL,
	uid int(10) NOT NULL default '0',
	from_month int(11) default NULL,
	from_year int(11) default NULL,
	to_month int(11) default NULL,
	to_year int(11) default NULL,
	cvitae_title text NOT NULL,
	cvitae_order smallint(3) NOT NULL default '0',
	PRIMARY KEY  (cvitae_id) );
CREATE TABLE xoonips_item_keyword   (
	item_id int(10) unsigned NOT NULL default '0',
	keyword_id int(10) unsigned NOT NULL default '0',
	keyword varchar(255) default NULL,
	PRIMARY KEY  (item_id,keyword_id),
	KEY keyword (keyword) );
CREATE TABLE xoonips_item_show   (
	item_id int(10) NOT NULL default '0',
	uid int(10) NOT NULL default '0',
	PRIMARY KEY  (item_id,uid)
	);
CREATE TABLE xoonips_item_title   (
	item_id int(10) unsigned NOT NULL default '0',
	title_id int(10) unsigned NOT NULL default '0',
	title varchar(255) default NULL,
	PRIMARY KEY  (item_id,title_id),
	KEY title (title) );
CREATE TABLE xoonips_positions   (
	posi_id smallint(5) NOT NULL,
	posi_title varchar(50) default NULL,
	posi_order smallint(3) NOT NULL default '0',
	PRIMARY KEY  (posi_id) );
CREATE TABLE xoonips_ranking_active_group   (
	gid int(10) unsigned NOT NULL,
	count int(10) unsigned NOT NULL,
	PRIMARY KEY  (gid) );
CREATE TABLE xoonips_ranking_contributing_user   (
	item_id int(10) unsigned NOT NULL,
	uid int(10) unsigned NOT NULL,
	timestamp timestamp NOT NULL default CURRENT_TIMESTAMP,
	PRIMARY KEY  (item_id) );
CREATE TABLE xoonips_ranking_downloaded_item   (
	item_id int(10) unsigned NOT NULL,
	count int(10) unsigned NOT NULL,
	PRIMARY KEY  (item_id) );
CREATE TABLE xoonips_ranking_new_group   (
	gid int(10) unsigned NOT NULL,
	timestamp timestamp NOT NULL default CURRENT_TIMESTAMP,
	PRIMARY KEY  (gid) );
CREATE TABLE xoonips_ranking_new_item   (
	item_id int(10) unsigned NOT NULL,
	timestamp timestamp NOT NULL default CURRENT_TIMESTAMP,
	PRIMARY KEY  (item_id) );
CREATE TABLE xoonips_ranking_searched_keyword   (
	keyword varchar(255) NOT NULL,
	count int(10) unsigned NOT NULL,
	PRIMARY KEY  (keyword) );
CREATE TABLE xoonips_ranking_sum_active_group   (
	gid int(10) unsigned NOT NULL,
	count int(10) unsigned NOT NULL,
	PRIMARY KEY  (gid) );
CREATE TABLE xoonips_ranking_sum_contributing_user   (
	item_id int(10) unsigned NOT NULL,
	uid int(10) unsigned NOT NULL,
	timestamp timestamp NOT NULL default CURRENT_TIMESTAMP,
	PRIMARY KEY  (item_id) );
CREATE TABLE xoonips_ranking_sum_downloaded_item   (
	item_id int(10) unsigned NOT NULL,
	count int(10) unsigned NOT NULL,
	PRIMARY KEY  (item_id) );
CREATE TABLE xoonips_ranking_sum_new_group   (
	gid int(10) unsigned NOT NULL,
	timestamp timestamp NOT NULL default CURRENT_TIMESTAMP,
	PRIMARY KEY  (gid) );
CREATE TABLE xoonips_ranking_sum_new_item   (
	item_id int(10) unsigned NOT NULL,
	timestamp timestamp NOT NULL default CURRENT_TIMESTAMP,
	PRIMARY KEY  (item_id) );
CREATE TABLE xoonips_ranking_sum_searched_keyword   (
	keyword varchar(255) NOT NULL,
	count int(10) unsigned NOT NULL,
	PRIMARY KEY  (keyword) );
CREATE TABLE xoonips_ranking_sum_viewed_item   (
	item_id int(10) unsigned NOT NULL,
	count int(10) unsigned NOT NULL,
	PRIMARY KEY  (item_id) );
CREATE TABLE xoonips_ranking_viewed_item   (
	item_id int(10) unsigned NOT NULL,
	count int(10) unsigned NOT NULL,
	PRIMARY KEY  (item_id) );
CREATE TABLE xoonips_search_cache   (
	search_cache_id int(10) unsigned NOT NULL,
	sess_id varchar(32) NOT NULL,
	timestamp timestamp NOT NULL default CURRENT_TIMESTAMP,
	PRIMARY KEY  (search_cache_id) );
CREATE TABLE xoonips_search_cache_file   (
	search_cache_id int(10) unsigned NOT NULL,
	file_id int(10) unsigned NOT NULL default '0',
	PRIMARY KEY  (search_cache_id,file_id) );
CREATE TABLE xoonips_search_cache_item   (
	search_cache_id int(10) unsigned NOT NULL,
	item_id int(10) unsigned NOT NULL default '0',
	PRIMARY KEY  (search_cache_id,item_id) );
CREATE TABLE xoonips_search_cache_metadata   (
	search_cache_id int(10) unsigned NOT NULL,
	identifier varchar(255) NOT NULL,
	PRIMARY KEY  (search_cache_id,identifier) );
CREATE TABLE xoonips_search_text (
	file_id int(10) unsigned NOT NULL,
	search_text longtext,
	PRIMARY KEY  (file_id),
	FULLTEXT KEY search_text (search_text) );
SQL
	;
		// queries
		if( !query_sqls($sqls) ){
			return false;
		}
		
		$result = xnp_refresh_item_status();
		if ( RES_OK != $result ){
			echo '&nbsp;&nbsp;'. "cannot refresh item status(${result})" .'<br />';
			return false;
		}
		
		xoonips_insert_default_positions();

		$module_handler =& xoops_gethandler('module');
		$module =& $module_handler->getByDirname('xoonips');
		
		$mid = $module->getVar('mid');
		$groupid_registered = 2;
		$groupid_anonymous = 3;
		
		$block_objects =& XoopsBlock::getByModule( $mid );
		$bids = array();
		foreach( $block_objects as $o )
			$bids[$o -> getVar( 'show_func' )] = $o -> getVar( 'bid' ); // If it is going to investigate by name, it will be troubled when language changes.
		if ( isset($bids['b_xoonips_itemtypes_show']) ){
			$gperm_handler =& xoops_gethandler('groupperm');
			$gperm_handler->addRight( 'block_read' , $bids['b_xoonips_itemtypes_show'], $groupid_anonymous  );
			xoonips_set_block_visible( $bids['b_xoonips_itemtypes_show'], false );
		}
		
		// itemtype block is arranged by center-center.
		global $xoopsDB;
		$blocks_tab = $xoopsDB->prefix('newblocks');
		$tfunc = 'b_xoonips_itemtypes_show';
		$result = $xoopsDB->query( "update $blocks_tab set side = 5 where show_func = '$tfunc'" );
		if( !$result ){
			echo '&nbsp;&nbsp;'. $xoopsDB -> error() . ", sql=$sql" .'<br />';
			return false;
		}

		
		$table = $xoopsDB -> prefix('newblocks');
		$tfunc = "b_xoonips_quick_search_show";
		$result = $xoopsDB->query( "SELECT name FROM $table WHERE show_func = '$tfunc'" );
		if( !$result ) {
			echo '&nbsp;&nbsp;'. $xoopsDB -> error() . ", sql=$sql" .'<br />';
			return false;
		}
		while( $row = $xoopsDB -> fetchArray($result) ){
			$newtitle = $row['name'];
			$upres = $xoopsDB->query( "UPDATE $table SET title = '$newtitle' where show_func = '$tfunc'" );
			if( !$upres ) {
				echo '&nbsp;&nbsp;'. $xoopsDB -> error() . ", sql=$sql" .'<br />';
				return false;
			}
		}
		
		// construt search_text here from file contents
		// (when you manipulating search_text column, you must call xnpExtractTextAll at the end of the case block)
		xnpExtractTextAll();

		// refresh search_text of oai metadata
		xnpRescanMetadata();
		
		//convert titles and keywords and then move to new tables
		$sql = "select item_id, title, keywords from ".$xoopsDB -> prefix( "xoonips_item_basic" );
		$result = $xoopsDB->query($sql);
		if( $result ){
			while( list( $item_id, $titles, $keywords ) = $xoopsDB->fetchRow($result) ){
				//titles
				$values = array();
				$i=0;
				foreach( preg_split( "/[\r\n]+/", $titles ) as $title ){
					$title = trim( $title );
					if( $title === '' ) continue;
					$values[] = "( ${item_id}, ${i}, '".addslashes( $title )."')";
					$i++;
				}
				if( count( $values ) == 0 ) continue;//process next item if no titles
				$sql = "insert into ".$xoopsDB -> prefix( "xoonips_item_title" )." (item_id,title_id,title) values ".implode( ",", $values );
				$result2 = $xoopsDB->query($sql);
				if( !$result2 ){
					echo '&nbsp;&nbsp;'. $xoopsDB -> error() . ", sql=$sql" .'<br />';
					return false;
				}
				
				//keywords
				$values = array();
				$i=0;
				foreach( explode( ",", $keywords ) as $keyword ){
					$keyword = trim( $keyword );
					if( $keyword === '' ) continue;
					$values[] = "( ${item_id}, ${i}, '".addslashes( $keyword )."')";
					$i++;
				}
				if( count( $values ) == 0 ) continue;//process next item if no keywords
				$sql = "insert into ".$xoopsDB -> prefix( "xoonips_item_keyword" )." (item_id,keyword_id,keyword) values ".implode( ",", $values );
				$result2 = $xoopsDB->query($sql);
				if( !$result2 ){
					echo '&nbsp;&nbsp;'. $xoopsDB -> error() . ", sql=$sql" .'<br />';
					return false;
				}

			}
		}
	
		xnpRecalcRanking(false);
	
	case 319:
		$sqls = <<<SQL
-- xoonips_file_type
ALTER TABLE xoonips_file_type MODIFY name VARCHAR(30) NOT NULL;
ALTER TABLE xoonips_file TYPE = innodb;
ALTER TABLE xoonips_index TYPE = innodb;
ALTER TABLE xoonips_index_item_link TYPE = innodb;
ALTER TABLE xoonips_item_basic TYPE = innodb;
ALTER TABLE xoonips_item_keyword TYPE = innodb;
ALTER TABLE xoonips_item_title TYPE = innodb;
ALTER TABLE xoonips_related_to TYPE = innodb;
ALTER TABLE xoonips_event_log TYPE = innodb;
ALTER TABLE xoonips_changelog TYPE = innodb;
ALTER TABLE xoonips_item_status TYPE = innodb;
SQL;
		// queries
		if( !query_sqls($sqls) ){
			return false;
		}
		
		// add datestamp if not eixsts in xoonips_oaipmh_metadata(only for Visiome)
		if( !fetch_column( 'xoonips_oaipmh_metadata', 'datestamp' ) ){
			$sql = sprintf( "ALTER TABLE %s ADD datestamp datetime default NULL", $xoopsDB->prefix( "xoonips_oaipmh_metadata" ) );
			$result = $xoopsDB->query($sql);
			if ( $result == false ){
				echo '&nbsp;&nbsp;'. $xoopsDB -> error() . ", sql=$sql" .'<br />';
				return false;
			}
		}
		
		// 
		// resolve not unique file_type_name 'presentation_file' and 'data_file'
		// 
		$module_handler =& xoops_gethandler('module');
		$module =& $module_handler->getByDirname('xnpconference');
		if( $module ){
			$sql = "update " . $xoopsDB -> prefix( "xoonips_file_type" ) . " set name='conference_file', display_name='Presentation file of Conference' where name='presentation_file' and mid=" . $module -> mid();
			$result = $xoopsDB->query($sql);
			if ( $result == false ){
				echo '&nbsp;&nbsp;'. $xoopsDB -> error() . ", sql=$sql" .'<br />';
				return false;
			}
		}
		$module =& $module_handler->getByDirname('xnpfiles');
		if( $module ){
			$result = $xoopsDB->query("update " . $xoopsDB -> prefix( "xoonips_file_type" ) . " set name='files_file', display_name='Data file of Files' where name='data_file' and mid=" . $module -> mid() );
			if ( $result == false ){
				echo '&nbsp;&nbsp;'. $xoopsDB -> error() . ", sql=$sql" .'<br />';
				return false;
			}
		}
		$sql = "ALTER TABLE ".$xoopsDB->prefix("xoonips_file_type")." ADD UNIQUE ( name )";
		if( $xoopsDB->query($sql) == false ){
			echo '&nbsp;&nbsp;'. $xoopsDB -> error() . ", sql=$sql" .'<br />';
			return false;
		}
	
		// set mid in xoonips_binder
		$module_table = $xoopsDB->prefix('modules');
		$itemtype_table = $xoopsDB->prefix('xoonips_item_type');
		$sql = "SELECT mid FROM $itemtype_table WHERE name='xoonips_binder'";
		$res = $xoopsDB->query($sql);
		if( !$res ){
			echo '&nbsp;&nbsp;'. $xoopsDB -> error() . ", sql=$sql" .'<br />';
		} else {
			while( $row = $xoopsDB->fetchArray($res) ){
				if( $row['mid'] == null ){
					$sql = "SELECT mid FROM $module_table WHERE dirname='xoonips'";
					$res = $xoopsDB->query($sql);
					if( !$res ){
						echo '&nbsp;&nbsp;'. $xoopsDB -> error() . ", sql=$sql" .'<br />';
					}
					$row = $xoopsDB->fetchArray( $res );
					$mid = intval( $row['mid'] );
					$sql = "UPDATE $itemtype_table SET mid = $mid WHERE name='xoonips_binder'";
					$res = $xoopsDB->query( $sql );
					if( !$res ){
						echo '&nbsp;&nbsp;'. $xoopsDB -> error() . ", sql=$sql" .'<br />';
					}
				}
			}
		}
		// modify xoonips_item_show
		$tab_name = $xoopsDB->prefix('xoonips_item_show');
		$sql = "SELECT * FROM $tab_name LIMIT 1";
		$res = $xoopsDB->query($sql);
		if( !$res ){
			echo '&nbsp;&nbsp;'.$xoopsDB->error(). " sql=$sql".'<br />';
		} else {
			$row = $xoopsDB->fetchArray($res);
			if( $row['show_id'] ){
				$sql = "DELETE FROM $tab_name WHERE show_state = '0'";
				$res = $xoopsDB->query($sql);
				if( !$res ){
					echo '&nbsp;&nbsp;'.$xoopsDB->error(). " sql=$sql".'<br />';
				}
				$sql = "ALTER TABLE $tab_name DROP show_id, DROP show_state";
				$res = $xoopsDB->query($sql);
				if( !$res ){
					echo '&nbsp;&nbsp;'.$xoopsDB->error(). " sql=$sql".'<br />';
				}
				$sql = "ALTER TABLE $tab_name ADD PRIMARY KEY (item_id, uid) ";
				$res = $xoopsDB->query($sql);
				if( !$res ){
					echo '&nbsp;&nbsp;'.$xoopsDB->error(). " sql=$sql".'<br />';
				}
			}
		}
	case 324:
		$sqls = <<<SQL
-- xoonips_file
ALTER TABLE xoonips_file
	MODIFY file_size int(10) unsigned NOT NULL default '0',
	MODIFY file_type_id int(10) unsigned NOT NULL default '0',
	ADD is_deleted TINYINT(1) UNSIGNED NOT NULL DEFAULT '0',
	ADD download_count INT(10) UNSIGNED NOT NULL DEFAULT '0';
-- xoonips_file_type
ALTER TABLE xoonips_file_type  MODIFY name VARCHAR(30) NOT NULL DEFAULT '';
-- xoonips_item_basic
ALTER TABLE xoonips_item_basic 
	DROP title,
	DROP keywords;
-- xoonips_item_keyword
ALTER TABLE xoonips_item_keyword  DROP PRIMARY KEY,
	ADD seq_id INT( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY FIRST,
	CHANGE keyword keyword VARCHAR( 255 ) NOT NULL default '',
	ADD UNIQUE (item_id ,keyword_id );
-- xoonips_item_title
ALTER TABLE xoonips_item_title  DROP PRIMARY KEY,
	ADD seq_id INT( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY FIRST,
	CHANGE title title VARCHAR( 255 ) NOT NULL default '',
	ADD UNIQUE (item_id ,title_id );
-- xoonips_position
ALTER TABLE xoonips_positions  ADD UNIQUE KEY posi_title (posi_title);
-- 
ALTER TABLE xoonips_ranking_active_group 
	MODIFY gid int(10) unsigned NOT NULL default '0',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_contributing_user 
	MODIFY item_id int(10) unsigned NOT NULL default '0',
	MODIFY uid int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_downloaded_item 
	MODIFY item_id int(10) unsigned NOT NULL default '0',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_new_group MODIFY gid int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_new_item MODIFY item_id int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_searched_keyword 
	MODIFY keyword varchar(255) NOT NULL default '',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_active_group 
	MODIFY gid int(10) unsigned NOT NULL default '0',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_contributing_user 
	MODIFY item_id int(10) unsigned NOT NULL default '0',
	MODIFY uid int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_downloaded_item 
	MODIFY item_id int(10) unsigned NOT NULL default '0',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_new_group MODIFY gid int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_new_item MODIFY item_id int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_searched_keyword 
	MODIFY keyword varchar(255) NOT NULL default '',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_viewed_item 
	MODIFY item_id int(10) unsigned NOT NULL default '0',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_viewed_item 
	MODIFY item_id int(10) unsigned NOT NULL default '0',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_related_to
	DROP PRIMARY KEY,
	ADD related_to_id int(10) unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY FIRST,
	MODIFY parent_id int(10) unsigned NOT NULL default '0',
	MODIFY item_id int(10) unsigned NOT NULL default '0',
    ADD UNIQUE KEY related_to (parent_id,item_id);
ALTER TABLE xoonips_search_cache MODIFY sess_id varchar(32) NOT NULL default '';
ALTER TABLE xoonips_search_cache_file MODIFY search_cache_id int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_search_cache_item
	DROP PRIMARY KEY,
	ADD search_cache_item_id int(10) NOT NULL AUTO_INCREMENT PRIMARY KEY FIRST,
	MODIFY search_cache_id int(10) unsigned NOT NULL default '0',
	ADD matchfor_index tinyint(1) NOT NULL default '0',
	ADD matchfor_item tinyint(1) NOT NULL default '0',
	ADD matchfor_file tinyint(1) NOT NULL default '0',
	ADD UNIQUE KEY search_cache_id (search_cache_id,item_id);
ALTER TABLE xoonips_search_cache_metadata 
	MODIFY search_cache_id int(10) unsigned NOT NULL default '0',
	MODIFY identifier varchar(255) NOT NULL default '';
ALTER TABLE xoonips_search_text MODIFY file_id int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_session MODIFY uid int(10) unsigned NOT NULL default '0';
SQL;

		// queries
		if( !query_sqls($sqls) ){
			return false;
		}
		
		// clean up unlinked item
		$xoopsDB -> query( sprintf( "DELETE FROM %s WHERE item_id=0", $xoopsDB -> prefix( 'xoonips_related_to' ) ) );
		$xoopsDB -> query( sprintf( "DELETE FROM %s WHERE item_id=0", $xoopsDB -> prefix( 'xoonips_index_item_link' ) ) );
		
		// enable use of notification 'file_downloaded'
		$config_handler =& xoops_gethandler('config');
		$module_id = $xoopsMod->getVar('mid');
		$criteria = new CriteriaCompo(new Criteria('conf_name', 'notification_events'));
		$criteria->add(new Criteria('conf_modid', $module_id));
		$criteria->add(new Criteria('conf_catid', 0));
		$config_items = $config_handler->getConfigs( $criteria );
		if ( count($config_items) != 1 ){
			echo '&nbsp;&nbsp;'. "module has " . count($config_items) . " notification_events options line at " . __LINE__ .'<br />';
		}
		else {
			$config_item = $config_items[0];
			$option_value = 'user-file_downloaded';
			$option_values = $config_item->getConfValueForOutput();
			if ( !in_array( $option_value, $option_values ) ){
				$option_values[] = $option_value;
				$config_item->setConfValueForInput( $option_values );
				$config_item_handler =& new XoopsConfigItemHandler($xoopsDB);
				$config_item_handler->insert($config_item);
			}
		}
	}
	xoonips_delete_obsolete_configs();
	return true;
}

/**
 * @split $sqls to individual queries, add prefix to table, and query sqls
 * output some informations to stdout.
 * 
 * @param string $sqls string of sqls.
 * @return boolean true if succeed
 * 
 */
function query_sqls($sqls){
	global $xoopsDB;
	$pieces = array();
	SqlUtility::splitMySqlFile($pieces, $sqls);
	$created_tables = array();
	$errs = array();
	$msgs = array();
	$error = false;
	$ret = '';
	foreach ($pieces as $piece) {
		// [0] contains the prefixed query
		// [4] contains unprefixed table name
		$prefixed_query = SqlUtility::prefixQuery($piece, $xoopsDB->prefix());
		if (!$prefixed_query) {
			$errs[] = "<b>$piece</b> is not a valid SQL!";
			$error = true;
			break;
		}
		if (!$xoopsDB->query($prefixed_query[0])) {
			$errs[] = $xoopsDB->error() . ' of SQL '.htmlspecialchars($prefixed_query[0]);
			$error = true;
			break;
		} else {
			
			if (strncmp('CREATE', strtoupper($prefixed_query[0]), 6) == 0 && !in_array($prefixed_query[4], $created_tables)) {
				$msgs[] = '&nbsp;&nbsp;Table <b>'.$xoopsDB->prefix($prefixed_query[4]).'</b> created.';
				$created_tables[] = $prefixed_query[4];
			}
		}
	}
	// if there was an error, delete the tables created so far, so the next installation will not fail
	if ($error == true) {
		foreach ($created_tables as $ct) {
			//echo $ct;
			$xoopsDB->query("DROP TABLE ".$xoopsDB->prefix($ct));
		}
	}
	
	if( $error ){
		foreach ($errs as $er) {
			$ret .= '&nbsp;&nbsp;'.$er.'<br />';
		}
		unset($msgs);
		unset($errs);
	}
	echo $ret;
	return !$error;
}

function fetch_column( $table, $column ){
	global $xoopsDB;
	$result = $xoopsDB -> query( 'SHOW COLUMNS FROM ' . $xoopsDB -> prefix( $table ) . ' WHERE Field = ' . $xoopsDB -> quoteString( $column ) );
    return $xoopsDB -> fetchArray( $result );
}
?>
