<?php
// $Id: tree.php,v 1.36.4.12 2007/06/25 05:21:06 orrisroot Exp $
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

/** display tree in iframe. Tree's state(open/close) and state checkbox are memorized in cookie.
 * input:
 *   $_GET['checkbox']
 *           0:no check in checkbox(default), 1:checked in checkbox
 *   $_GET['url']
 *           Page that user moves to when user clicks index.
 *           no $_GET['url']: listeitem.php(default),  "": don't link
 *           not to contain since '?'
 *   $_GET['form']
 *           Name of form to submit when users click index.
 *           we can specify form in window.top.document.
 *           for xoonips/itemselect.php
 *           When the arguments of forms are given, 
 *           form.action, index_id in form, and op in form change and submit in clicked index change.
 *           And argument of url is invalid.
 *   $_GET['hide_binders']
 *           0:not hide Binders(default), 1:hide Binders
 *   $_GET['edit']
 *           0:display only readable index(default), 1:display only editable index
 *   $_GET['on_check_private_handler_id']
 *           Specified: Id of the element that has function 'onCheckPrivate'.
 *           If the Id is given, callback onCheckPrivate of the element
 *           when a number of selected private indexes is zero or not.
 *           Not specified: nothing to do.
 *   $_GET['selected_tab']
 *           No specified:Select tab that selected last time(default), specified:select the specified tab.
 *   $_GET['edit_binder']
 *           Specified:display Private and Public. Display only Binder's checkbox in Public tab.
 *   (If there is window.top.form[].xoonipsCheckedXID, get initial value in checkbox.)
 *   $_GET['edit_public']
 *           Specified:display Public if su.
 *   $_GET['puid']
 *           displaying a user's tree specified by puid if xoopsUser is moderator and puid is specified.
 * 
 * output:
 *   nothing. Getting state of checkbox in onSubmit isn't work of 'tree.php'.
 */

/*
  the font used in a tree is specified like following in css of theme
    div  .tree { font definition }

  for example
    .tree {
        font-family: Times;
        font-size: 10pt;
        font-weight: bold;
    }

*/

/*
  Succession of information in Open/Close, Checked, and Tab.
  Save/Load information of Open/Close, Checked are done by onUnload, onLoad in tree.php.
  Information of select Tabs are restored byonLoad in tree.php
  Display only Public and Private, when making a Binder. State of Open/Close in group got lost in this case.
  Tab is selected Public's.
  
  Open/Close and Tab in iframe: (in)Initial value are succeeded. (out)When user clicks tab, tab is switched.
    if ( cookie has initial value. ){
      Open/Close = ( get from Cookie )
      select Tab = ( get from Open/Close )
    }
    else {
      Open/Close = ( open only first one )
      select Tab = first one
    }
    
    if ( mode of editting and making Binder ){
      open Public, PrivateTab
      select Tab = Public
    }
  
*/

/* 

opened 
	opened: state of open/close in tree
	
	node:
		n           : This parameter leads xoonips_tree_nodes[n].
		xid
		child
		isOpened    : open/close
		startOpened
		isLast      : last child node. 1/0  Need to change image in last.
		lastinfo    : ex."001010" it's ancestor's isLast tied.
	
	default
	  isOpened = false
	  startOpened = ( isRoot ? true : false )
	
	mozilla) when node opens, can't drawn again in multiple structure of table. open->close->open->close:The table doesn't expand and contract well.
	IE) If checkboxes add in tree under document, the checks are cleared.
	IE) If checkbox.name is set, can't retrieve by getElementsByName. http://msdn.microsoft.com/library/default.asp?url=/workshop/author/dhtml/reference/properties/name_2.asp
	IE) there is the case that can't scroll right position in scrollTo. http://www.issociate.de/board/post/273978/Why_is_the_scrolling_function_not_working_with_Internet_Explorer.html
*/


//	$times = array();
//	$times[__LINE__] = posix_times();
	//$xoopsOption['pagetype'] = 'user';
	$xoopsOption['pagetype'] = "pmsg";
	include_once "../../mainfile.php";

//	$times[__LINE__] = posix_times();
	include_once XOOPS_ROOT_PATH.'/class/module.textsanitizer.php';
	include_once XOOPS_ROOT_PATH . '/modules/system/constants.php';

	$config_handler =& xoops_gethandler('config');
	$xoopsConfigUser =& $config_handler->getConfigsByCat(XOOPS_CONF_USER);

	require_once 'include/create_session.php';
	require_once 'include/encode.php';
	include_once 'condefs.php';
	xnp_load_init_create_session();
	$xnpsid = $_SESSION['XNPSID'];
	

// get variables
$myts =& MyTextSanitizer::getInstance();

$get_keys = array(
  'checkbox' => array( 'type' => 'b', 'default' => false ),
  'url' => array( 'type' => 's', 'default' => 'listitem.php' ),
  'form' => array( 'type' => 's', 'default' => '' ),
  'hide_binders' => array( 'type' => 'b', 'default' => false ),
  'edit' => array( 'type' => 'b', 'default' => false ),
  'on_check_private_handler_id' => array( 'type' => 's', 'default' => '' ),
  'selected_tab' => array( 'type' => 'i', 'default' => '' ),
  'edit_binder' => array( 'type' => 'b', 'default' => false ),
  'edit_public' => array( 'type' => 'b', 'default' => false ),
  'puid' => array( 'type' => 'i', 'default' => 0 ),
);
$get_vals = array();
foreach ( $get_keys as $key => $meta ) {
  if ( ! isset( $_GET[$key] ) ) {
    $val = $meta['default'];
  } else {
    switch( $meta['type'] ) {
    case 'b': // boolean : 0 or 1
      $val = !empty( $_GET[$key] );
      break;
    case 'i': // integer 
      $val = intval( $_GET[$key] );
      break;
    case 's': // string
      $val = $myts->stripSlashesGPC( $_GET[$key] );
      break;
    }
  }
  $get_vals[$key] = $val;
}

// get variable check
if ( strpos( $get_vals['url'], '?' ) !== false ) {
  die( 'error: url' );
}
if ( !empty( $get_vals['form'] ) && preg_match( '/^([0-9A-Za-z_]+)$/', $get_vals['form'] ) != 1 ) {
  die( 'error: form' );
}

$xoonips_url = htmlspecialchars( $get_vals['url'], ENT_QUOTES );
$xoonips_formname = htmlspecialchars( $get_vals['form'], ENT_QUOTES );
$xoonips_on_check_private_handler_id = htmlspecialchars( $get_vals['on_check_private_handler_id'], ENT_QUOTES );

	// tree node images
    $tree_swap_image_path = $xoopsConfig['theme_set'].'/'.XOONIPS_TREE_SWAP_IMAGE_DIR;
    if( is_dir(XOOPS_THEME_PATH.'/'.$tree_swap_image_path) ) {
		$xoops_themes_dir = str_replace(XOOPS_ROOT_PATH, '', XOOPS_THEME_PATH);
		define("T1_GIF", "../..".$xoops_themes_dir."/".$tree_swap_image_path."/t1.gif");
		define("T2_GIF", "../..".$xoops_themes_dir."/".$tree_swap_image_path."/t2.gif");
		define("T3_GIF", "../..".$xoops_themes_dir."/".$tree_swap_image_path."/t3.gif");
		define("T4_GIF", "../..".$xoops_themes_dir."/".$tree_swap_image_path."/t4.gif");
		define("T5_GIF", "../..".$xoops_themes_dir."/".$tree_swap_image_path."/t5.gif");
		define("T6_GIF", "../..".$xoops_themes_dir."/".$tree_swap_image_path."/t6.gif");
		define("T7_GIF", "../..".$xoops_themes_dir."/".$tree_swap_image_path."/t7.gif");
		define("T8_GIF", "../..".$xoops_themes_dir."/".$tree_swap_image_path."/t8.gif");
		define("T9_GIF", "../..".$xoops_themes_dir."/".$tree_swap_image_path."/t9.gif");
	}
    else {
		define("T1_GIF", "images/t1.gif");
		define("T2_GIF", "images/t2.gif");
		define("T3_GIF", "images/t3.gif");
		define("T4_GIF", "images/t4.gif");
		define("T5_GIF", "images/t5.gif");
		define("T6_GIF", "images/t6.gif");
		define("T7_GIF", "images/t7.gif");
		define("T8_GIF", "images/t8.gif");
		define("T9_GIF", "images/t9.gif");
	}
	
	if ( !empty($xoopsUser) ){
		$uid = $xoopsUser->getVar('uid');
	}
	else {
		$uid = UID_GUEST;
	}

	if ( $uid == UID_GUEST && !public_item_target_user_all() ){
		// 
		// for guest access, show message that access to index tree is forbidden.
		// 
		xoops_header( false );
		echo "</head><body><div style='font-size: 10pt;'>";
		echo _MD_XOONIPS_INDEX_FORBIDDEN;
		echo "</div>";
		xoops_footer();
		exit;
	}

	include_once 'include/gentree.php';
	
	$indexes = genIndexTree0( $xnpsid );
	$is_moderator = xnp_is_moderator( $xnpsid, $uid );
	
	if ( $is_moderator && $get_vals['puid'] > 0 )
		$puid = $get_vals['puid'];
	else
		$puid = $uid;
	
	if ( $get_vals['edit_binder'] )
		filterPublicPrivateIndex( $indexes, $puid );
	else if ( $is_moderator )
		filterMyIndex( $indexes, $xnpsid, $puid );
	else
		;
	
	if ( $get_vals['edit'] )
		filterEditableIndex( $indexes, $xnpsid, $uid, $puid, $get_vals['edit_public'] && !empty($_SESSION['xoonips_old_uid']) );
	
	if ( $get_vals['hide_binders'] )
		filterNonbinderIndex( $indexes );
	
	$indexes = genIndexTree1( $indexes );
	
	// get number of items under nodes (by index).
	// use special function.
	$itemCounts = array();
	$result = xnp_get_item_count_group_by_index( $xnpsid, $itemCounts );
	$xid2n = array();
	
	$ct = count($indexes);
	for ( $i = 0; $i < $ct; $i++ ){ // can't change value in foreach
		$index = &$indexes[$i];
		$index_id = $index['item_id'];
		$index['n'] = $i;
		$index['checkPrivate'] = (int)( $index['open_level'] == OL_PRIVATE );
		$index['hasCheckbox'] = (int)( $get_vals['edit_binder'] ?
		     ( $index_id == IID_BINDERS || $index['open_level'] != OL_PUBLIC ) :
		     ( $index_id != IID_BINDERS && $get_vals['checkbox'] )
		);
		$xid2n[$index_id] = $i;
	}
	unset( $index );
	
?>
<<?php echo "?"; ?>xml version="1.0" encoding="<?php echo _CHARSET;?>">
<?php
	xoops_header( false );
?>
<LINK rel="stylesheet" type="text/css" href="style.css" />
<script type="text/javascript" src="treelib.js">
</script>
<script type="text/javascript">
<!-- // Hide script from old browsers
<?php
  readfile( 'include/tree.inc.js' );
?>

var xoonips_tree_cookie = new XooNIpsTreeJS.Cookie( false, false, 0, false );
var xoonips_tree_tab_control = new XooNIpsTreeJS.TabControl( xoonips_tree_cookie, 'xoonipsSelectedTab2', 'xoonipScroll' );

function xoonips_on_click_img( n ){
	setOpened( n, !Boolean(xoonips_tree_nodes[n].isOpened) );
	return false;
}

function xoonips_toggle_checkbox( xid ){
	var checkbox = document.getElementById( 'xoonips_tree_checkbox_' + xid );
	if ( checkbox ){
		var b = checkbox.checked;
		checkbox.checked = !b;
		if ( checkbox.onclick )
			checkbox.onclick();
	}
	return false;
}


var treeHere;
var xoonips_url = "<?php echo $xoonips_url; ?>";
var linkIsCheckbox = <?php echo (int)( $get_vals['checkbox'] || $get_vals['edit_binder'] ); ?>;
var xoonips_formname = "<?php echo $xoonips_formname; ?>";
var xid2n = {};
var checkedPrivateCount = 0;

function xoonips_tree_node_info( n_, xid_, child_, hasCheckbox_, checkPrivate_, isLast_, title_ ){
	this.n = n_;
	this.xid = xid_;
	this.child = child_;
	this.hasCheckbox = hasCheckbox_;
	this.checkPrivate = checkPrivate_;
	this.isLast = isLast_;
	this.title = title_;
	this.isOpened = false;
	this.onceOpened = false;
	xid2n['x'+xid_] = n_;
}

<?php

       $xoonips_tree_nodes_html = '';
       $xoonips_tree_roots_html = '';
	
	function xnpEntity2Ecma262sub( $str ){
		return sprintf( '\\u%04x', (int)$str[1] );
	}
	// \ -> \\
	// " -> \"
	// < -> \x3c
	// > -> \x3e
	// \r-> \r
	// \n-> \n
	// &#ddddd; => \uxxxx(ECMA262)
	// EUC characters in $str => unicode (in browser)
	function xnpEntity2Ecma262($str){
		return preg_replace_callback('/&#([0-9]+);/i', 'xnpEntity2Ecma262sub', 
		  str_replace(array('\\', '"', '<', '>', "\r", "\n"), array('\\\\', '\\"', '\\x3c', '\\x3e', '\\r', '\\n'), $str ));
	}
	
	$length = count($indexes);
	$nodes_sep = "";
	$roots_sep = "";
	foreach( $indexes as $i => $index ){

                // tree nodes
		$xid         = $index['item_id'];
		$childCount  = $index['child_count'];
		$isLast      = $index['is_last'] ? 1 : 0;
		$hasCheckbox = $index['hasCheckbox'];
		$checkPrivate= $index['checkPrivate'];
		$htmlTitle   = xnpEntity2Ecma262($index['titles'][DEFAULT_INDEX_TITLE_OFFSET]);
		$itemCount   = isset($itemCounts[$xid]) ? $itemCounts[$xid] : 0;
		if ( $itemCount )
			$htmlTitle .= "($itemCount)";
		
		if ( $childCount == 0 ){
                        $xoonips_tree_nodes_html .=  "$nodes_sep new xoonips_tree_node_info( $i, $xid, null, $hasCheckbox, $checkPrivate, $isLast, \"$htmlTitle\" )\n";
		}
		else {
			$ar = array();
			foreach ( $index['child'] as $dummy => $child_xid )
				$ar[] = $xid2n[$child_xid];
			$xoonips_tree_nodes_html .= "$nodes_sep new xoonips_tree_node_info( $i, $xid, [" . implode( ',', $ar ) . "], $hasCheckbox, $checkPrivate, $isLast, \"$htmlTitle\" )\n";
		}
		$nodes_sep = ",";

                // tree roots
		if ( $index['depth'] == 1 ){
			$xoonips_tree_roots_html .= $roots_sep . $i;
			$roots_sep = ",";
		}

	}

?>
var xoonips_tree_nodes = [
<?php echo $xoonips_tree_nodes_html; ?>
];

var xoonips_tree_roots = [
<?php echo $xoonips_tree_roots_html; ?>
];


function set_child_node_open( n, is_open ) {
  var div = document.getElementById( 'xoonips_tree_node_child' + n );
  div.style.display =  ( is_open ? 'block' : 'none' );
}

function create_child_node_block( n, parent ) {
  var div = document.createElement( 'DIV' );
  parent.appendChild( div );
  div.style.display = 'none';
  div.id = 'xoonips_tree_node_child' + n;
}

function setOpened( n, opened ){
//	window.alert( 'setopened:' + n );
	var node = xoonips_tree_nodes[n];
	if ( node.isOpened == opened )
		return;
	
	var child = node.child;
	if ( child == null ){
		return;
	}
	
	var len = child.length;
	
	if ( !node.onceOpened ){
		if ( opened ){
			// create child nodes
			//window.alert( 'creating : ' + n );
			var parentNode = document.getElementById( 'xoonips_tree_node_child' + n );
			var lastinfo = node.lastinfo;
			for ( var i = 0; i < len; i++ ){
				var child_n = child[i];
				var isLast = ( i == len-1 ) || ( lastinfo == "" );
				CreateClosedElem( child_n, lastinfo, isLast, parentNode );
				
				if ( xoonips_tree_nodes[child_n].startOpened )
					setOpened( child_n, true );
			}
			node.onceOpened = true;
		}
	}
        set_child_node_open( n, opened );
	node.isOpened = opened;
}

function CreateClosedElem( n, lastinfo, isLast, parent ){
	var node = xoonips_tree_nodes[n];
	if ( node == null ) return false;
	
	node.isLast = isLast;
	node.lastinfo = lastinfo + ( isLast ? "1" : "0" );
	//node.lastinfo = lastinfo;
	
	var text = document.createTextNode( node.title );
	var div = document.createElement('DIV');
	parent.appendChild( div );
	div.id = 'node' + n;
	div.style.height = '19px';
	div.style.whiteSpace = 'nowrap';
	lastinfo = node.lastinfo;
	var len = lastinfo.length-1;
	
	if ( 0 < len ){
		for ( var i = 0; i < len; i++ ){
			var img = document.createElement('IMG');
			div.appendChild( img );
			if ( i == 0 )                         { img.width =  3; img.height = 19; img.src = '<?php echo T9_GIF; ?>'; }
			else if ( lastinfo.charAt(i) == "1" ) { img.width = 10; img.height = 19; img.src = '<?php echo T4_GIF; ?>'; }
			else                                  { img.width = 10; img.height = 19; img.src = '<?php echo T2_GIF; ?>'; }
		}
/*
		span = document.createElement('span');
		span.width = len*10-7;
		span.height = 19;
		span.src = '<?php echo T2_GIF; ?>';
		div.appendChild( span );
*/
	}
	
	var img = document.createElement('IMG');
	div.appendChild( img );
	if ( node.child == null ){
		if ( len == 0 )                         img.src = '<?php echo T7_GIF; ?>';
		else if ( lastinfo.charAt(len) == "1" ) img.src = '<?php echo T3_GIF; ?>';
		else                                    img.src = '<?php echo T1_GIF; ?>';
	}
	else {
		if ( len == 0 )                         img.src = '<?php echo T8_GIF; ?>';
		else if ( lastinfo.charAt(len) == "1" ) img.src = '<?php echo T6_GIF; ?>';
		else                                    img.src = '<?php echo T5_GIF; ?>';
		img.onclick = function(){ return xoonips_on_click_img( n ); };
	}

	
	if ( node.hasCheckbox ){
		var checkbox = document.createElement( 'INPUT' );
		checkbox.type = 'checkbox';
		checkbox.id = 'xoonips_tree_checkbox_' + node.xid;
		checkbox.name = 'c' + node.xid;
		div.appendChild( checkbox );
		
		if ( node.checkPrivate )
			checkbox.onclick = function() { return xoonips_on_click_checkbox( n, this.checked ); };
		
		var hidden_checkbox = document.getElementById( 'xoonips_tree_checkbox_hidden_' + node.xid );
		if ( hidden_checkbox ){
			if ( hidden_checkbox.parentNode )
				hidden_checkbox.parentNode.removeChild( hidden_checkbox );
			checkbox.checked = true;
		}
	}
	
	if ( xoonips_formname ){
		var a = document.createElement( 'A' );
		a.className = 'tree';
		a.onclick = function() { return xoonips_submit( node.xid ); };
		a.target = '_top';
		
		div.appendChild( a );
		a.appendChild( text );
	}
	else if ( linkIsCheckbox ){
		if ( node.hasCheckbox ){
			var a = document.createElement( 'A' );
			a.className = 'tree';
			a.href = '';
			a.onclick = function() { return xoonips_toggle_checkbox( node.xid ); };
			a.target = '_top';
			
			div.appendChild( a );
			a.appendChild( text );
		}
		else {
			var span = document.createElement( 'SPAN' );
			span.className = 'tree';
			div.appendChild( span );
			span.appendChild( text );
		}
	}
	else if ( xoonips_url ){
		var a = document.createElement( 'A' );
		a.className = 'tree';
		a.href = xoonips_url + '?index_id=' + node.xid;
		a.target = '_top';
		
		div.appendChild( a );
		a.appendChild( text );
	}
	else {
		var span = document.createElement( 'SPAN' );
		span.className = 'tree';
		div.appendChild( span );
		span.appendChild( text );
	}
	
        // child node block
        create_child_node_block( n, parent );
}

function getOpenState(){
	var len = xoonips_tree_nodes.length;
	var opens = new Array();
	var slen = 0;
	for ( var i = 0; i < len; i++ ){
		if ( xoonips_tree_nodes[i].isOpened )
			opens[slen++] = xoonips_tree_nodes[i].xid;
	}
	return opens.join(',');
}

function getCheckState(){
	var inputs = document.getElementsByTagName( 'input' );
	var len = inputs.length;
	var checks = new Array();
	var slen = 0;
	for ( var i = 0; i < len; i++ ){
		var name = inputs[i].name;
		var index_id = name.substr(1);
		if ( inputs[i].checked )
			checks[slen++] = index_id;
	}
	return checks.join( ',' );
}

function initializeTree( openXids ){
  // set startOpened flag
  var opened_xids = openXids.split(',');
  for ( var i = 0; i < opened_xids.length; i++ ) {
    var xid = opened_xids[i];
    if ( xid == '' ) {
      continue;
    }
    var n = xid2n['x'+xid];
    if ( n == undefined ) {
      continue;
    }
    xoonips_tree_nodes[n].startOpened = true;
  }
	
	var endmark = document.getElementById('xoonipsTreeEndmark');
	for ( var i = 0; i < xoonips_tree_roots.length; i++ ){
		var n = xoonips_tree_roots[i];
		var xid = xoonips_tree_nodes[n].xid;
		var div = document.createElement( 'DIV' );
		var id = 'xoonips_tree_root' + n;
		treeHere.insertBefore( div, endmark );
		div.id = id;
		CreateClosedElem( n, "", true, div );
		setOpened( n, true ); // create top-level node(public/group/private)
		xoonips_tree_tab_control.registerTab( id, xid );
	}
	
}

/**
 * The Index Tree controll functions.
 *   These functions will called from tree block on top window.
 *   - xoonips_tree_apply_openAll()    : open all tree node
 *   - xoonips_tree_apply_closeAll()   : close all tree node
 *   - xoonips_tree_apply_clearCheck() : clear all checkboxes
 *   - xoonips_tree_apply_selectTab()  : switch tree tab
 */
function xoonips_tree_apply_openAll(){
  var len = xoonips_tree_nodes.length;
  for ( var i = 0; i < len; i++ ){
    setOpened( i, true );
  }
}

function xoonips_tree_apply_closeAll(){
  var len = xoonips_tree_nodes.length;
  for ( var i = 0; i < len; i++ ){
    setOpened( i, false );
  }
}

function xoonips_tree_apply_clearCheck(){
  var checkboxes = document.getElementsByTagName( 'INPUT' );
  var len = checkboxes.length;
  for ( var i = 0; i < len; i++ )
    checkboxes[i].checked = false;
}

function xoonips_tree_apply_selectTab( n ) {
  return xoonips_tree_tab_control.selectTab( n );
}

function onLoad(){
  // register functions for tree block on top window
  treeHere = document.getElementById('xoonipsTreeHere');
  treeHere.openAll    = xoonips_tree_apply_openAll;
  treeHere.closeAll   = xoonips_tree_apply_closeAll;
  treeHere.clearCheck = xoonips_tree_apply_clearCheck;
  treeHere.selectTab  = xoonips_tree_apply_selectTab;
	
	var checkedInputs = window.top.document.getElementsByName( 'xoonipsCheckedXID' );
	if ( checkedInputs.length != 0 ){
		xoonipsCheckState2 = checkedInputs.item(0).value;
	}
	else {
		xoonipsCheckState2 = xoonips_tree_cookie.getCookie( 'xoonipsCheckState2' );
	}
	
	xoonipsOpenState2 = xoonips_tree_cookie.getCookie( 'xoonipsOpenState2' );
	initializeTree(String(xoonipsOpenState2));
	
	// load select tab
	// tab selection priority:
        // $_GET['selected_tab'] > cookie:xoonipsSelectedTab2 > min(xid)
	var selected_tab = "<?php echo $get_vals['selected_tab']; ?>";
	if ( ! ( selected_tab ) ) {
		selected_tab = xoonips_tree_cookie.getCookie( 'xoonipsSelectedTab2' );
	}
        // validate xid
	var xid = Number( selected_tab );
	if ( ! ( xid > 0 && window.top.document.getElementById( 'xoonipsTab' + xid ) ) ) {
		xid = xoonips_tree_nodes[xoonips_tree_roots[0]].xid;
	}
	// call tab open function
	if ( window.top.document.xoonipsOpenTab ) {
		window.top.document.xoonipsOpenTab( xid );
	} else {
		xoonips_tree_tab_control.selectTab( xid );
	}
	
	// restore check state
	if ( xoonipsCheckState2 ){
		var checks = xoonipsCheckState2.split( ',' );
		var hiddenCheckHere = document.getElementById('hiddenCheckHere');
		len = checks.length;
		
		for ( i = 0; i < len; i++ ){
			var xid = checks[i];
			var n = xid2n['x'+xid];
			
			if ( n == undefined ) // invalid xid
				continue;
                        var checkbox = document.getElementById( 'xoonips_tree_checkbox_' + xid );
			if ( checkbox ){
				checkbox.checked = true;
			}
			else {
				var hidden_checkbox = document.createElement( 'INPUT' );
				hidden_checkbox.type = 'checkbox';
				hidden_checkbox.id = 'xoonips_tree_checkbox_hidden_' + xid;
				hidden_checkbox.name = 'c' + xid;
				hiddenCheckHere.appendChild( hidden_checkbox );
				hidden_checkbox.checked = true;
			}
			if ( xoonips_tree_nodes[n].checkPrivate )
				checkedPrivateCount++;
		}
	}
	
	xoonips_action_checkbox_event();
}

// save tree state to cookie
function onUnload(){
  var open_state = getOpenState();
  var check_state = getCheckState();
  xoonips_tree_cookie.setCookie( 'xoonipsOpenState2', open_state );
  xoonips_tree_cookie.setCookie( 'xoonipsCheckState2', check_state );
  xoonips_tree_tab_control.saveSelectedTab();
}

<?php

if ( !empty( $xoonips_formname ) ) {
	// submit form in click
?>
function xoonips_submit( xid ){
	var index_id = xid;
	var form = window.top.document.getElementsByName( xoonips_formname ).item(0);
	if ( form == null ){
		window.alert( 'form element not found' );
		return false;
	}
	// 
	var objs = window.top.document.getElementsByName("index_id");
	var i;
	for ( i = 0; i < objs.length; i++ ){
		var obj = objs.item(i);
		if ( obj.form == form ){
			// send with index_id
			obj.value = index_id;
			break;
		}
	}
	if ( i == objs.length ){
		window.alert( 'index_id element not found' );
		return false;
	}
	
	objs = window.top.document.getElementsByName("op");
	for ( i = 0; i < objs.length; i++ ){
		var obj = objs.item(i);
		if ( obj.form == form ){
			// send with index_id
			obj.value = 'index';
			break;
		}
	}
	if ( i == objs.length ){
		window.alert( 'op element not found' );
		return false;
	}
	
	form.action = "<?php echo XOOPS_URL . '/modules/xoonips/itemselect_register.php'; ?>";
	form.submit();
	return false;
}
<?php
	}
?>

function isPrivateChecked(){
	return ( 0 < checkedPrivateCount );
}

function xoonips_on_click_checkbox( n, is_checked ) {
	if ( xoonips_tree_nodes[n].checkPrivate ){
		if ( is_checked ) checkedPrivateCount++;
		else              checkedPrivateCount--;
	}
	// window.alert( 'checked=' + checkedPrivateCount );
	xoonips_action_checkbox_event();
	return true;
}

function xoonips_action_checkbox_event() {
	var id = "<?php echo $xoonips_on_check_private_handler_id; ?>";
	if ( id ){
		var c = window.top.document.getElementById(id);
		if( c != null ){
			if( c.onCheckPrivate ){
				var b = isPrivateChecked();
				c.onCheckPrivate( b );
			}else{
				alert( 'onCheckPrivate function not defined' );
			}
		}else{
			alert( "element id not found" );
		}
	}
}

// End script hiding -->    
</script>
</head>

<body onLoad="onLoad();" onUnload="onUnload();">
<form action="#">
<div class="directory" id='xoonipsTreeHere'>
 <div id='xoonipsTreeEndmark'>
 </div>
 <div id='hiddenCheckHere' style='display: none;' >
 </div>
</div>
</form>
<?php
/*	foreach ( $times as $key=>$val ){
		echo " $key " . $val['ticks'] . "<br>";
	}
*/
	xoops_footer();
?>
